#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String[] = "Yes Sir, that's my baby. No Sir, I don't mean maybe.";
#define Strlen	(sizeof(String)-1)


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char inbuf[_POSIX_MAX_INPUT];

	setup(E_INTERFACE);
	funct(E_INTERFACE);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(39, BASE)
		GTI_NOT_PROVIDED_RESULT(40, BASE)
		GTI_NOT_PROVIDED_RESULT(41, BASE)
		done();
	}

	exit_on(ERROR);

						/*  Noncanonical Mode Input Processing */
						/* MIN = 0, TIME = 0 */
	assertion(39, BASE);
	start
		prep("Establish PORT_TTY as the control terminal, and PORT_LOOP.");
		prep("Setup PORT_TTY in non-canonical mode.");
		prep("Set on PORT_TTY MIN=0 and TIME=0.");
		start
			exit_on(ERROR);
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);

								/* Set for non-canonical mode. */
			tty_termios_p->c_lflag &= ~(ICANON | ECHO);
			tty_termios_p->c_cc[VMIN] = 0;
			tty_termios_p->c_cc[VTIME] = 0;
			Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);
		finis

		testing("Enough data written, data successfully read.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);

				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
				expecting(Strlen);
				Zread(tty_fildes, inbuf, Strlen);
			CLEAR_ALARM
		finis
	finis

	assertion(40, BASE);
	start
		testing("Read() requesting more data than available returns data");
		testing("available.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);

				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_CANON);
			CLEAR_ALARM
		finis
	finis

					/* No data written, zero bytes read. */
	assertion(41, BASE);
	start
		testing("No data written, zero bytes read.");
		start
			SET_TIMEOUT
				expecting(0);
				Zread(tty_fildes, inbuf, _POSIX_MAX_CANON);
			CLEAR_ALARM
		finis
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(tty_fildes);
		Zclose(loop_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
