#include	<pcts_ass.h>

#include	<termios.h>
#include	<sv_env.h>

struct	cnt_msk {
		const char	*name;
		const unsigned long	mask;
		} cnt_msks[] = {
			"CLOCAL", CLOCAL,
			"CREAD", CREAD,
			"CSIZE", CSIZE,
			"CSTOPB", CSTOPB,
			"HUPCL", HUPCL,
			"PARENB", PARENB,
			"PARODD", PARODD,
	};
#define	NUM_CNTS	(sizeof(cnt_msks)/sizeof(cnt_msks[0]))

struct	sz_msk {
		const char	*name;
		const unsigned long	mask;
		} sz_msks[] = {
			"CS5", CS5,
			"CS6", CS6,
			"CS7", CS7,
			"CS8", CS8,
	};
#define	NUM_SZ	(sizeof(sz_msks)/sizeof(sz_msks[0]))


int	main(void)
{
	unsigned long	i, j;

	setup(E_SETTABLE);
	funct(E_SETTABLE);

	assertion(37, BASE);
	start
		testing ("When <termios.h> is included the c_cflag mask values");
		testing("are defined and bitwise distinct from each other.");
		start
			BITWISE_DISTINCT(cnt_msks, NUM_CNTS);
		finis
	finis

	assertion(38, BASE);
	start
		testing("When <termios.h> is included, the CS5, CS6, CS7, and CS8");
		testing("bit masks are defined to have distinct values.");
		start
			for( i=0; i<NUM_SZ; i++ )
				for( j=i+1; j<NUM_SZ; j++ )
					if(sz_msks[i].mask == sz_msks[j].mask)
						error("Element %s (value %d) not a distinct value.",
									sz_msks[i].name, sz_msks[i].mask);
		finis

		testing("CSIZE is defined as a mask that includes all bits in the");
		testing("bitwise inclusive OR of CS5|CS6|CS7|CS8.");
		start
			if( ((CS5|CS6|CS7|CS8) & CSIZE) != (CS5|CS6|CS7|CS8) )
				error("%s\n%s%x\n%s%x\n",
					"CSIZE does not include the masks CS5, CS6, CS7, and CS8.",
					"CSIZE is ",
					CSIZE,
					"CS5|CS6|CS7|CS8 is ",
					CS5|CS6|CS7|CS8 );
		finis
	finis

	done();
}
