#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

unsigned char NL	= '\n';
char String[] =  "Yes Sir, That's my baby.  No Sir, I don't mean maybe";
#define	Strlen	(sizeof(String)-1)

void	cnv_hex(char *, char *, int);

int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	union in {
		char	inbuf[_POSIX_MAX_INPUT];
		cc_t	scc;
	} in_data;

	int	cnt_exp;

	setup(E_SETTABLE);
	funct(E_SETTABLE);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(60, BASE)
		GTI_NOT_PROVIDED_RESULT(61, BASE)
		GTI_NOT_PROVIDED_RESULT(62, BASE)
		GTI_NOT_PROVIDED_RESULT(63, BASE)
		GTI_NOT_PROVIDED_RESULT(64, BASE)
		GTI_NOT_PROVIDED_RESULT(65, BASE)
		GTI_NOT_PROVIDED_RESULT(66, BASE)
		GTI_NOT_PROVIDED_RESULT(67, BASE)
		GTI_NOT_PROVIDED_RESULT(68, BASE)
		done();
	}

											/* ECHO */
	assertion(60, BASE);
	start
		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		prep("Set ECHO flag for PORT_TTY.");
		start
			exit_on(ERROR);
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);

			tty_termios_p->c_lflag |= ECHO;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		prep("Write and read data.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				expecting(sizeof(char));
				Zwrite(loop_fildes, (char *)&NL, sizeof(char));
				Ztcdrain(loop_fildes);
			CLEAR_ALARM

			dt_secs(TIME_ACQUIRE_XMITTED_DATA);

			SET_TIMEOUT
				expecting(Strlen + sizeof(char));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

		testing("When ECHO is set, input characters are echoed back");
		testing("to the terminal.");
		start
			break_on(ERROR);
			SET_TIMEOUT
				Ztcdrain(tty_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM


			SET_TIMEOUT
				expecting(Strlen + sizeof(char));
				Zread(loop_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(strncmp(String, in_data.inbuf, Strlen) != 0)
				error("%s\n%s%*s\n%s%*s",
						"Echo string != written string.",
						"Expected: ",
						Strlen,
						String,
						"Echoed: ",
						Strlen,
						in_data.inbuf);
		finis
	finis

											/* ~ECHO */
	assertion(61, BASE);
	start
		prep("Clear ECHO for PORT_TTY, then write and read data.");
		start
			tty_termios_p->c_lflag &= ~ECHO;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
			Ztcflush(loop_fildes, TCIOFLUSH);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				expecting(sizeof(char));
				Zwrite(loop_fildes, (char *)&NL, sizeof(char));
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(Strlen+1);
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

		testing("When ECHO is clear, input characters are not echoed back");
		testing("to the terminal.");
		start
			SET_TIMEOUT
				Ztcdrain(tty_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(0);
				Zread(loop_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis


											/* ECHOE */
	assertion(62, BASE);
	start
		prep("Set ECHO and ECHOE for PORT_TTY, then write and read data.");
		start
			tty_termios_p->c_lflag |= (ECHO|ECHOE);
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VERASE]);

				expecting(sizeof(NL));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(Strlen - 1 + sizeof(char));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

		testing("When ICANON, ECHOE, ECHO are set, and ERASE is received");
		testing("then the {PCTS_ECHOE} string is sent to the terminal.");
		start
			SET_TIMEOUT
				Ztcdrain(tty_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				cnt_exp = Strlen + sizeof(NL) +strlen(PCTS_ECHOE);
				expecting(cnt_exp);
				Zread(loop_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(strncmp(in_data.inbuf +Strlen, PCTS_ECHOE, strlen(PCTS_ECHOE))
																		!= 0) {
				char	e_buf[200], r_buf[200];

				cnv_hex(PCTS_ECHOE, e_buf, strlen(PCTS_ECHOE));
				cnv_hex(in_data.inbuf +Strlen, r_buf, cnt_exp -Strlen);
				error("%s\n%s[%s(Hex)]\n%s[%s(Hex)]\n",
					"Expected erase sequence was not received.",
					"Expected: ",
					e_buf,
					"Received: ",
					r_buf);
			}
		finis
	finis

												/* ICANON & ECHOK */
	assertion(63, BASE);
	start
		prep("Set ECHO and ECHOK for PORT_TTY, then write and read data.");
		start
			tty_termios_p->c_lflag &= ~ECHOE;
			tty_termios_p->c_lflag |= (ICANON | ECHO | ECHOK);
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
			Ztcflush(loop_fildes, TCIOFLUSH);
		finis

		prep("Write data followed by KILL character, then read it.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VKILL]);
				expecting(sizeof(NL));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(sizeof(NL));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

		testing("PCTS_ECHOK string is returned to sender.");
		start
			break_on(ERROR);
			SET_TIMEOUT
				Ztcdrain(tty_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				cnt_exp = Strlen;
				Zread(loop_fildes, in_data.inbuf, Strlen);
				cnt_exp = strlen(PCTS_ECHOK);
				expecting(cnt_exp +sizeof(NL));
				Zread(loop_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(strncmp(in_data.inbuf, PCTS_ECHOK, cnt_exp) != 0) {
				char	e_buf[200], r_buf[200];

				cnv_hex(PCTS_ECHOK, e_buf, cnt_exp);
				cnv_hex(in_data.inbuf, r_buf, cnt_exp);
				error("%s\n%s[%s(Hex)]\n%s[%s(Hex)]\n",
					"Expected kill erase sequence was not received.",
					"Expected: ",
					e_buf,
					"Received: ",
					r_buf);
			}
		finis
	finis

												/* ICANON & ECHONL */
	assertion(64, BASE);
	start
		prep("Set ECHO and ECHONL for PORT_TTY, then write and read data.");
		start
			tty_termios_p->c_lflag &= ~ECHOK;
			tty_termios_p->c_lflag |= (ICANON|ECHONL|ECHO);
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				expecting(sizeof(NL));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(Strlen + sizeof(NL));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

		testing("The new line character is returned to sender.");
		start
			SET_TIMEOUT
				Ztcdrain(tty_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(Strlen + sizeof(NL));
				Zread(loop_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(in_data.inbuf[Strlen] != '\n')
				error("New line character not returned.");
		finis

		prep("Clear ECHO set ECHONL for PORT_TTY, then write and read data.");
		start
			tty_termios_p->c_lflag &= ~ECHO;
			Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				expecting(sizeof(NL));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(Strlen + sizeof(NL));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
				Ztcdrain(tty_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM
		finis

		testing("The new line character is returned to sender.");
		start
			break_on(ERROR);

			SET_TIMEOUT
				expecting(sizeof(NL));
				Zread(loop_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(in_data.inbuf[0] != '\n')
				error("ECHONL failed.");
		finis
	finis

	assertion(65, BASE);
	start
										/* ICANON */
										/* ~ISIG, NOFLSH, and INTR received. */
		prep("Clear ISIG and set NOFLSH on PORT_TTY, then send INTR.");
		start
			tty_termios_p->c_lflag &= ~ISIG;
			tty_termios_p->c_lflag |= NOFLSH;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SIGNAL(SIGINT, sig_int);
			sig_rcvd = 0;
			WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VINTR]);
			expecting(sizeof(char));
			Zwrite(loop_fildes, (char *)&NL, sizeof(char));
			Ztcdrain(loop_fildes);
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);
		finis

		testing("INTR is placed on the input queue and no special character");
		testing("functions occur.");
		start
			SET_TIMEOUT
				expecting(sizeof(cc_t) +sizeof(NL));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(sig_rcvd != 0)
				error("INTR generated a SIGINT.");
			if(tty_termios_p->c_cc[VINTR] != in_data.scc)
				error("Data received does not match INTR sent.");
		finis


										/* ~ISIG, NOFLSH, and quit received. */
		prep("Clear ISIG on PORT_TTY, then send QUIT.");
		start
			tty_termios_p->c_lflag &= ~ISIG;
			tty_termios_p->c_lflag |= NOFLSH;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SIGNAL(SIGQUIT, sig_int);
			sig_rcvd = 0;
			WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VQUIT]);
			expecting(sizeof(char));
			Zwrite(loop_fildes, (char *)&NL, sizeof(char));
			Ztcdrain(loop_fildes);
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);
		finis

		testing("QUIT is placed on the input queue and no special character");
		testing("functions occur.");
		start
			break_on(ERROR);

			SET_TIMEOUT
				expecting(sizeof(cc_t) +sizeof(NL));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(sig_rcvd != 0)
				error("QUIT generated a SIGQUIT.");
			if(tty_termios_p->c_cc[VQUIT] != in_data.scc)
				error("Data received does not match QUIT sent.");
		finis

											/* Repeat with ~ICANON */
		prep("Set PORT_TTY to non-canonical, MIN=TIME=0.");
		start
			tty_termios_p->c_lflag &= ~ICANON;
					/* Return number of bytes requested or that available. */
			tty_termios_p->c_cc[VMIN] = 0;
			tty_termios_p->c_cc[VTIME] = 0;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis
										/* ~ISIG, NOFLSH, and INTR received. */
		prep("Clear ISIG and set NOFLSH on PORT_TTY, then send INTR.");
		start
			tty_termios_p->c_lflag &= ~ISIG;
			tty_termios_p->c_lflag |= NOFLSH;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SIGNAL(SIGINT, sig_int);
			sig_rcvd = 0;
			WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VINTR]);
			Ztcdrain(loop_fildes);
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);
		finis

		testing("INTR is placed on the input queue and no special character");
		testing("functions occur.");
		start
			SET_TIMEOUT
				expecting(sizeof(cc_t));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(sig_rcvd != 0)
				error("INTR generated a SIGINT.");
			if(tty_termios_p->c_cc[VINTR] != in_data.scc)
				error("Data received does not match INTR sent.");
		finis


										/* ~ISIG, NOFLSH, and quit received. */
		prep("Clear ISIG on PORT_TTY, then send QUIT.");
		start
			tty_termios_p->c_lflag &= ~ISIG;
			tty_termios_p->c_lflag |= NOFLSH;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SIGNAL(SIGQUIT, sig_int);
			sig_rcvd = 0;
			WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VQUIT]);
			Ztcdrain(loop_fildes);
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);
		finis

		testing("QUIT is placed on the input queue and no special character");
		testing("functions occur.");
		start
			break_on(ERROR);

			SET_TIMEOUT
				expecting(sizeof(cc_t));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(sig_rcvd != 0)
				error("QUIT generated a SIGQUIT.");
			if(tty_termios_p->c_cc[VQUIT] != in_data.scc)
				error("Data received does not match QUIT sent.");
		finis
	finis


	assertion(66, BASE);
	start
										/* ~ISIG, NOFLSH and SUSP received. */
		prep("Clear ISIG and set NOFLSH on PORT_TTY, then send SUSP.");
		start
			tty_termios_p->c_lflag |= ICANON;
			tty_termios_p->c_lflag &= ~ISIG;
			tty_termios_p->c_lflag |= NOFLSH;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SIGNAL(SIGTSTP, sig_int);
			sig_rcvd = 0;
			WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSUSP]);
			expecting(sizeof(NL));
			Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
			Ztcdrain(loop_fildes);
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);
		finis

		testing("SUSP is placed on the input queue and no special character");
		testing("functions occur.");
		start
			break_on(ERROR);

			SET_TIMEOUT
				expecting(sizeof(cc_t) +sizeof(NL));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(sig_rcvd != 0)
				error("SUSP generated a SIGTSTP.");
			if(tty_termios_p->c_cc[VSUSP] != in_data.scc)
				error("Data received does not match SUSP sent.");
		finis

	finis


	assertion(67, BASE);
	start
		sigset_t	set;
										/* ISIG, NOFLSH, and INTR received. */
		prep("Set ISIG and NOFLSH on PORT_TTY, then send data and INTR.");
		start
			tty_termios_p->c_lflag |= (NOFLSH|ISIG);
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SIGNAL(SIGINT, sig_int);
			SIGBLOCK(set, SIGINT);
			sig_rcvd = 0;
			expecting(Strlen);
			Zwrite(loop_fildes, String, Strlen);
			WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VINTR]);
			expecting(sizeof(NL));
			Zwrite(loop_fildes, (char *)&NL, sizeof(NL));

			expecting(Strlen);
			Zwrite(loop_fildes, String, Strlen);
			expecting(sizeof(NL));
			Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
			tcdrain(loop_fildes);				/* Allow for interrupt. */
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);
		finis

									/* INTR is discarded since ISIG is set. */
		testing("Data is left on the input queue.");
		start
			SIGUNBLOCK(set, SIGINT);

			SET_TIMEOUT
				expecting(Strlen +sizeof(NL));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
				expecting(Strlen +sizeof(NL));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(sig_rcvd == 0)
				error("INTR did not generate a SIGINT.");
		finis


										/* ISIG, NOFLSH, and quit received. */
		prep("Set ISIG and NOFLSH on PORT_TTY, then send data and QUIT.");
		start
			tty_termios_p->c_lflag |= (NOFLSH|ISIG);
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SIGNAL(SIGQUIT, sig_int);
			SIGBLOCK(set, SIGQUIT);
			sig_rcvd = 0;
			expecting(Strlen);
			Zwrite(loop_fildes, String, Strlen);
			WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VQUIT]);
			expecting(sizeof(NL));
			Zwrite(loop_fildes, (char *)&NL, sizeof(NL));

			expecting(Strlen);
			Zwrite(loop_fildes, String, Strlen);
			expecting(sizeof(NL));
			Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
			tcdrain(loop_fildes);				/* Allow for interrupt. */
		finis

									/* QUIT is discarded since ISIG is set. */
		testing("Data is left on the input queue.");
		start
			SIGUNBLOCK(set, SIGQUIT);
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);

			SET_TIMEOUT
				expecting(Strlen +sizeof(NL));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
				expecting(Strlen +sizeof(NL));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(sig_rcvd == 0)
				error("QUIT did not generate a SIGQUIT.");
		finis
	finis


	assertion(68, BASE);
	start
		sigset_t	set;
										/* ISIG, NOFLSH and SUSP received. */
		prep("Set ISIG and NOFLSH on PORT_TTY, then send data and SUSP.");
		start
			tty_termios_p->c_lflag |= (NOFLSH|ISIG);
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SIGNAL(SIGTSTP, sig_int);
			SIGBLOCK(set, SIGTSTP);
			sig_rcvd = 0;
			expecting(Strlen);
			Zwrite(loop_fildes, String, Strlen);
			WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSUSP]);
			expecting(sizeof(NL));
			Zwrite(loop_fildes, (char *)&NL, sizeof(NL));

			expecting(Strlen);
			Zwrite(loop_fildes, String, Strlen);
			expecting(sizeof(NL));
			Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
			tcdrain(loop_fildes);				/* Allow for interrupt. */
		finis

									/* SUSP is discarded since ISIG is set. */
		testing("Data is left on the input queue.");
		start
			SIGUNBLOCK(set, SIGTSTP);
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);

			SET_TIMEOUT
				expecting(Strlen +sizeof(NL));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
				expecting(Strlen +sizeof(NL));
				Zread(tty_fildes, in_data.inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(sig_rcvd == 0)
				error("SUSP did not generate a SIGTSTP.");
		finis

	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(loop_fildes);
		Zclose(tty_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}


				/*	Convert string to hex character string.
					Account for bits per byte and bytes per character.
				*/
void	cnv_hex(char *in, char *out, int nbytes)
{
	char	*pin, *pout, *pend;

	pend = in +(nbytes/sizeof(char));
	for(pin = in, pout = out, *pout = '\0';
			pin < pend; pin++, pout = out +(strlen(out) / sizeof(char))) {
		sprintf(pout, "%*x", sizeof(char)*2, (int)(*pin)); 
		if(*pout == ' ')
			*pout = '0';
	}
}
