#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<Ztermios.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>


int main(void)
{
	int	tty_fildes, notty_fildes;
	struct termios	tty_termios, *tty_termios_p = &tty_termios;

	setup(E_TCFLOW);
	funct(E_TCFLOW);

	assertion(14, BASE);
	start
		testing("Call to tcflow() with an invalid file descriptor.");
		start
			expecting(EBADF);
			expecting(-1);
			Ztcflow(-1, TCION);
		finis
	finis

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(15, BASE)
	}
	else {
		assertion(15, BASE);
		start
			prep("Establish PORT_TTY as the control terminal.");
			start
				tty_prep(&tty_fildes, tty_termios_p);
			finis

			testing("Call to tcflow() for an invalid action.");
			start
				expecting(EINVAL);
				expecting(-1);
				Ztcflow(tty_fildes, -1);
			finis
		finis

		cleanup("Close terminal device files.");
		start
			Zclose(tty_fildes);
			SLEEP(GTI_LINE_CLOSE_DELAY)
		finis
	}

	assertion(16, BASE);
	start
		testing("Call to tcflow() when file descriptor is not a terminal.");
		start
			notty_fildes = temp_open("notspec", O_RDWR | O_CREAT, PERM_CTTY);
			expecting(ENOTTY);
			expecting(-1);
			Ztcflow(notty_fildes, TCION);
		finis
	finis

	done();
}
