#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	pid_t	fg_pgrp, ct_pgrp, pid;

	setup(E_TCGETPGRP);
	funct(E_TCGETPGRP);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(4, BASE)
		done();
	}

	assertion(4, BASE);
	start
		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		start
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);
			tty_termios_p->c_lflag &= ~TOSTOP;
			Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);
		finis

		testing("Call to tcgetpgrp() from foreground process.");
		start
			fg_pgrp = Zgetpgrp();
			ct_pgrp = Ztcgetpgrp(tty_fildes);

			if(ct_pgrp != fg_pgrp)
				error("%s\n%s\n%s%ld\n%s%ld",
						"Expect foreground process group ID to be the same"
						"as controlling terminal process group ID."
						"Foreground process group ID is ",
						(long) fg_pgrp,
						"Controlling terminal process group ID is ",
						(long) ct_pgrp);
		finis

		FORK
			testing("Call to tcgetpgrp() from background process.");
			start
				Zsetpgid((pid_t)0, (pid_t)0);
				ct_pgrp = Ztcgetpgrp(tty_fildes);
				if(ct_pgrp != fg_pgrp)
					error("%s\n%s\n%s%ld\n%s%ld",
							"Expect foreground process group ID to be the same"
							"as controling terminal process group ID."
							"Foreground process group ID is ",
							(long) fg_pgrp,
							"Controlling terminal process group ID is ",
							(long) ct_pgrp);
			finis
		KROF
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(tty_fildes);
		Zclose(loop_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
