#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<sys/Ztimes.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>


int	main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	int	io_diff = TRUE;		/*	TRUE if IUT supports different INPUT and
								OUTPUT baud rates on GTI port. */

	setup(E_TCSETATTR);
	funct(E_TCSETATTR);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(11, BASE)
		done();
	}

	assertion(11, BASE);
	start
		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		prep("Determine if support for different rates for input and output");
		prep("on the same port exists on this IUT.");
		start
			exit_on(ERROR);

			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);
			
			continue_on(ERROR);
					/* Output baud rates already set to maximum configured. */
					/* Attempt to set input baud rate to minimum configured. */
			Ztcgetattr(loop_fildes, loop_termios_p);
			Zcfsetospeed(loop_termios_p, baud_max());
			Zcfsetispeed(loop_termios_p, baud_min());
										/*	Split baud rate supported?	*/
			tcsetattr(loop_fildes, TCSANOW, loop_termios_p);
			Ztcgetattr(loop_fildes, loop_termios_p);
			if(cfgetispeed(loop_termios_p) == cfgetospeed(loop_termios_p))
				io_diff = FALSE;
		finis

		if(io_diff == TRUE) {
			testing("When the input baud rate in the termios structure is set");
			testing("to zero and tcsetattr() is called, then the input baud");
			testing("rate is changed to the value of the output baud rate as");
			testing("specified in the termios structure.");
			start
				Zcfsetispeed(loop_termios_p, B0);
				Ztcsetattr(loop_fildes, TCSANOW, loop_termios_p);
				Ztcgetattr(loop_fildes, loop_termios_p);
				if(cfgetispeed(loop_termios_p) != baud_max())
					error("%s\n%s%d\n%s%d\n",
							"Input speed not set properly.",
							"Expected: ",
							baud_max(),
							"Actual: ",
							cfgetispeed(loop_termios_p));
			finis
		} else
				not_implemented("INPUT and OUTPUT baud rates cannot differ");
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(loop_fildes);
		Zclose(tty_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
