#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<sys/Ztimes.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String[] = "How now, brown cow?\n";
#define	Strlen	(sizeof(String) -1)


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];
	pid_t	pid;
	sigset_t	set;

	setup(E_TCSETATTR);
	funct(E_TCSETATTR);

	SIGNAL(SIGHUP, SIG_IGN);

	assertion(13, BASE);
	start
		GTI_NOT_PROVIDED_EXIT

		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		start
			exit_on(ERROR);

			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);
							/* Set TOSTOP before becoming background process. */
			Ztcgetattr(tty_fildes, tty_termios_p);
			tty_termios_p->c_lflag |= TOSTOP;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		prep("Write to PORT_LOOP.");
		start
			expecting(Strlen);
			Zwrite(loop_fildes, String, Strlen);
			Ztcdrain(loop_fildes);
		finis

		FORK
			prep("Establish background process group with two processes.");
			start
				Zsetpgid((pid_t)0, (pid_t)0);
				SIGNAL(SIGTTOU, sig_int);
				sig_rcvd = 0;
			finis

			prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				testing("Child process in background process group");
				testing("received SIGTTOU signal.");
				start
					sleep(WAIT_FOR_TIME);
					if(sig_rcvd == 0)
						error("Child process did not receive SIGTTOU.");
				finis

				done();
			}
	
			testing("Call to tcsetattr(), on the controlling terminal of");
			testing("the process, from a member of a background");
			testing("process group that is not blocking or ignoring the");
			testing("SIGTTOU signal when TOSTOP is set is unsuccessful.");
			start
				SIGUNBLOCK(set, SIGTTOU);
				SET_TIMEOUT
					tty_termios_p->c_oflag |= OPOST;
					expecting(FAILURE);
					Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
				CLEAR_ALARM
			finis

			testing("SIGTTOU signal is sent to calling process.");
			start
				dt_secs(1);
				if(sig_rcvd == 0)
					error("Calling process did not receive SIGTTOU.");
			finis

			testing("Terminal attribute is not changed.");
			start
				Ztcgetattr(tty_fildes, tty_termios_p);
				if((tty_termios_p->c_oflag & OPOST) == OPOST)
					error("Terminal attribute was set.");
			finis

			WAIT_FOR_PID(pid);
		KROF

									/* Repeat for TOSTOP flag clear. */
		prep("Clear TOSTOP flag.");
		start
						/* Clear TOSTOP before becoming background process. */
			Ztcgetattr(loop_fildes, loop_termios_p);
			loop_termios_p->c_lflag &= ~TOSTOP;
			Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);
		finis

		FORK
			prep("Establish background process group with two processes.");
			start
				Zsetpgid((pid_t)0, (pid_t)0);
				SIGNAL(SIGTTOU, sig_int);
				sig_rcvd = 0;
			finis

			prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				testing("Child process in background process group");
				testing("received SIGTTOU signal.");
				start
					sleep(WAIT_FOR_TIME);
					if(sig_rcvd == 0)
						error("Child process did not receive SIGTTOU.");
				finis

				done();
			}
	
			testing("Call to tcsetattr(), on the controlling terminal of");
			testing("the process, from a member of a background");
			testing("process group that is not blocking or ignoring the");
			testing("SIGTTOU signal when TOSTOP is clear is unsuccessful.");
			start
				SIGUNBLOCK(set, SIGTTOU);
				SET_TIMEOUT
					tty_termios_p->c_oflag |= OPOST;
					expecting(FAILURE);
					Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
				CLEAR_ALARM
			finis

			testing("SIGTTOU signal is sent to calling process.");
			start
				dt_secs(1);
				if(sig_rcvd == 0)
					error("Calling process did not receive SIGTTOU.");
			finis

			testing("Terminal attribute is not changed.");
			start
				Ztcgetattr(tty_fildes, tty_termios_p);
				if((tty_termios_p->c_oflag & OPOST) == OPOST)
					error("Terminal attribute was set.");
			finis
	
			WAIT_FOR_PID(pid);
		KROF

		testing("PORT_TTY queue was not flushed.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(loop_fildes);
		Zclose(tty_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
