#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	pid_t	ct_pgrp, par_pgrp, pid;

	setup(E_TCSETPGRP);
	funct(E_TCSETPGRP);

	assertion(4, BASE);
	start
		GTI_NOT_PROVIDED_EXIT

		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		start
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);
		finis

		ENABLE_PSYNC
		prep("Fork process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Establish child process as a background process.");
			start
				ct_pgrp = Ztcgetpgrp(tty_fildes);
				par_pgrp = Zgetpgrp();
				Zsetpgid((pid_t)0, (pid_t)0);		/* Background process */
				SEND_PSYNC
			finis

			SET_TIMEOUT
				WAIT_PSYNCA;
			CLEAR_ALARM

			testing("Call to tcsetpgrp() from parent changed child process");
			testing("to foreground process.");
			start
				if(Ztcgetpgrp(tty_fildes) != getpid())
					error("%s\n%s%ld\n%s%ld",
						"Controlling terminal process group ID not changed.",
						"Expected: ",
						(long) getpid(),
						"Actual: ",
						(long) tcgetpgrp(tty_fildes));
			finis

					/* Reset child to background process. */
			testing("Call to tcsetpgrp() sets the process group ID associated");
			testing("with the controlling terminal to \"pgrp_id\".");
			start
				Ztcsetpgrp(tty_fildes, ct_pgrp);
				if(Ztcgetpgrp(tty_fildes) != ct_pgrp)
					error("%s\n%s%ld\n%s%ld",
							"Controlling terminal process group ID not reset.",
							"Expected: ",
							(long) ct_pgrp,
							"Actual: ",
							(long) tcgetpgrp(tty_fildes));
			finis

			done();
		}

		SET_TIMEOUT
			WAIT_PSYNC;		/* Child changing to background process. */
		CLEAR_ALARM

		testing("Call to tcsetpgrp() sets the process group ID associated");
		testing("with the controlling terminal to \"pgrp_id\".");
		start
			Ztcsetpgrp(tty_fildes, pid);
			if(Ztcgetpgrp(tty_fildes) != pid)
				error("%s\n%s%ld\n%s%ld",
						"Controlling terminal process group ID not set.",
						"Expected: ",
						(long) pid,
						"Actual: ",
						(long) tcgetpgrp(tty_fildes));
			SEND_PSYNCA
		finis
		WAIT_FOR_PID(pid);
		DISABLE_PSYNC
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(tty_fildes);
		Zclose(loop_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
