#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>

#include	<sv_env.h>
#include	<sv_errno.h>

static	char	path[_POSIX_PATH_MAX +1];
static	char	path_cmp[_POSIX_PATH_MAX +1];
static	char	path_cwd[_POSIX_PATH_MAX +1];

void d_no_change(void);

int main(void)
{
	setup(E_CHDIR);
	funct(E_CHDIR);

	assertion(20, BASE);
	start
		prep("Initialize a path name.");
		start
			Zgetcwd(path_cwd, _POSIX_PATH_MAX +1);
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_perm.d");
			Zstrcat(path, "/chdir_tryme");
		finis

		testing("Call to chdir() when search permission for path is denied.");
		start
			expecting(-1);
			expecting(EACCES);
			Zchdir(path);
		finis

		d_no_change();
	finis

	if(tc_name_max()) {
		assertion(21, BASE);
		start
			e_NO_TRUNC(E_CHDIR);

			d_no_change();
		finis
	}
	else
		assertion(21, NOT_TESTABLE);

	if(!tc_name_max()) {
		assertion(22, BASE);
		start
			e_NO_TRUNC(E_CHDIR);
		finis
	}
	else
		assertion(22, NOT_TESTABLE);

	assertion(23, BASE);
	start
		e_ENAMETOOLONG(E_CHDIR);

		if(tc_path_max())
			d_no_change();
	finis

	assertion(24, BASE);
	start
		testing("Call to chdir() when path component is not a directory.");
		start
			temp_creat("stat_dir", PROT_ALL);
			Zstrcpy(path, temp_path());
			Zstrcat(path, "stat_dir/dummy_point");

			expecting(-1);
			expecting(ENOTDIR);
			Zchdir(path);
		finis

		d_no_change();
	finis

	assertion(25, BASE);
	start
		testing("Named directory does not exist.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "_chdir_");

			expecting(-1);
			expecting(ENOENT);
			Zchdir(path);
		finis

		d_no_change();
	finis

	assertion(26, BASE);
	start
		testing("Call to chdir() when path prefix does not exist.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "_chdir_/test");

			expecting(-1);
			expecting(ENOENT);
			Zchdir(path);

			d_no_change();
		finis
	finis

	assertion(27, BASE);
	start
		testing("Call to chdir() when path is an empty string.");
		start
			expecting(-1);
			expecting(ENOENT);
			Zchdir("");
		finis

		d_no_change();
	finis

	done();
}

void d_no_change(void)
{
	testing("The current working directory has not changed.");
	start
		Zgetcwd(path_cmp, _POSIX_PATH_MAX +1);
		if(strcmp(path_cmp, path_cwd)) {
			error("%s\n%s%s\n%s%s\n",
				  "Current working directory has changed.",
				  "Expected: ",
				  path_cwd,
				  "Actual: ",
				  path_cmp);
			Zchdir(path_cwd);		/* Return to normal working directory. */
		}
	finis
}
