#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	DIRNAME		"5.6.5_acc.d"
#define	FILENAME	"5.6.5_acc"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1], path_dir[_POSIX_PATH_MAX +1];
	int		i;
	union	u {
				char	*p_beg;
				gid_t	*g_beg;
			} u;
	gid_t	*s_gids;
	long	n_grps;
	int		n_getgrp;

	setup(E_CHOWN);
	funct(E_CHOWN);

					/*	Restrict the testing to a FIPS 151-2 required feature
						(changing the group to one of its supplementary groups
						IDs when the effective user ID is the owner of the file)
						to allow the test to be compatible to all FIPS 151-2
						implementations.

					*/
	exit_on(ERROR);
	assertion(18, BASE);
	start
		prep("Establish path to a directory such that search access");
		prep("exists on path prefix and on directory.");
		start
			sprintf(path_dir, "%s%s", temp_path(), DIRNAME);
			sprintf(path, "%s/%s", path_dir, FILENAME);

			Zmkdir(path_dir, PROT_ALL);
			Zclose(Zcreat(path, PROT_ALL));	/* All permissions on file */
			Zchmod(path_dir, S_IXUSR);		/* Search access on path prefix */
		finis

		prep("Obtain supplementary group IDs."); 
		start
				/*	Number of supplementary groups plus possibly the
					effective group ID if not included in the count
				*/
			n_grps = Zsysconf(_SC_NGROUPS_MAX) +1;
				/* Add +1 for adding effective group ID to array in case
				   the implementation does not provide it from getgroups()
				*/
			u.p_beg = (char *) Zmalloc((size_t)(sizeof(gid_t)*(n_grps +1)));
			n_getgrp = Zgetgroups((int)n_grps, u.g_beg);
										/* Add process group ID to list */
			s_gids = u.g_beg;
			s_gids[n_getgrp] = getegid();
		finis

		testing("A call to chown() is successful using path provided when");
		testing("changing group ID to another supplementary group ID.");
		start
			for(i=0; i<n_grps; i++, s_gids++)
				Zchown(path, UID, *s_gids);
		finis

		cleanup("Remove test files.");
		start
			Zchmod(path_dir, PROT_ALL);
			unlink(path);
			rmdir(path_dir);
		finis
	finis
	
	done();
}
