#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME	"5.3.2_37"

int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	path_par[_POSIX_PATH_MAX +1];
	int	fd;

	setup(E_CREAT);
	funct(E_CREAT);

	assertion(37, BASE);
	start
		time_t	s_time;

		prep("Initialize path to parent's directory for test file.");
		start
			Zstrcpy(path_par, temp_path());
			Zstrcpy(path, path_par);
			Zstrcat(path, FILENAME);
			unlink(path);			/*	Ensure test file does not exist. */
		finis

		prep("Obtain a starting time, then call creat().");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/

			fd = Zcreat(path, PROT_ALL);
		finis
	
		testing("Time related fields \"st_ctime\", \"st_mtime\", and");
		testing("\"st_atime\" of the file are marked for update.");
		start
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_ATIME, TRUE, s_time, NO_FILDES, path);
		finis

		testing("Time related fields \"st_ctime\" and \"st_mtime\"");
		testing("of parent directory are marked for update.");
		start
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path_par);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path_par);
			Zclose(fd);
		finis
	finis

	assertion(38, BASE);
	start
		time_t	s_time;

		prep("Obtain a starting time, then call creat() for an existing file.");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/

			fd = Zcreat(path, PROT_ALL);
		finis
	
		testing("Time related fields \"st_ctime\" and \"st_mtime\"");
		testing("of the file are marked for update.");
		start
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
		finis
	finis

	done();
}
