#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME "5.2.2_05.d"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	path_cwd[_POSIX_PATH_MAX +1];
	char	*ret_val;

	setup(E_GETCWD);
	funct(E_GETCWD);

	assertion(5, BASE);
	start
		testing("Size equal 0.");
		start
			expecting(NULL);
			expecting(EINVAL);
			Zgetcwd(path, 0);
		finis
	finis

	assertion(6, BASE);
	start
		break_on(ERROR);
		testing("Size greater than zero and less than length of");
		testing("actual pathname +1.");
		start
			int	pth_sz;

			expecting(NULL);
			expecting(ERANGE);
			Zgetcwd(path, 1);

			Zgetcwd(path, _POSIX_PATH_MAX +1);
			pth_sz = Zstrlen(path);
			expecting(NULL);
			expecting(ERANGE);
			Zgetcwd(path, pth_sz);
		finis

	finis

	assertion(7, BASE);
	start
		prep("Create a directory and establish it as the current working");
		prep("directory.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			Zmkdir(path, PROT_ALL);
			Zchdir(path);
			ret_val = Zgetcwd(path, _POSIX_PATH_MAX +1);
		finis

		prep("Remove read permission from current working directory, then");
		prep("call getcwd().");
		start
			Zchmod(path, S_IWUSR | S_IXUSR);

			ret_val = getcwd(path_cwd, _POSIX_PATH_MAX +1);
		finis

		if(ret_val == NULL) {
			testing("Returns NULL and errno set to [EACCES].");
			start
				if(errno != EACCES)
					error("%s\n%s%s\n",
						"Expected errno of [EACCES] on NULL return.",
						"Actual errno is ",
						err_lookup(errno));
			finis
		}
		else {
			testing("Call togetcwd() returns the current working directory.");
			start
				if(strcmp(path, path_cwd))
					error("%s\n%s\"%s\"\n%s\"%s\"\n",
						"Returned current working directory incorrect.",
						"Expected:	",
						path,
						"Obtained:	",
						path_cwd);
			finis
		}
	finis

	assertion(8, BASE);
	start
		prep("Add read permission and remove search permission from");
		prep("current working directory, then call getcwd().");
		start
			Zchmod(path, S_IWUSR | S_IRUSR);

			ret_val = getcwd(path_cwd, _POSIX_PATH_MAX +1);
		finis

		if(ret_val == NULL) {
			testing("Returns NULL and errno set to [EACCES].");
			start
				if(errno != EACCES)
					error("%s\n%s%s\n",
						"Expected errno of [EACCES] on NULL return.",
						"Actual errno is ",
						err_lookup(errno));
			finis
		}
		else {
			testing("getcwd() returns the current working directory.");
			start
				if(strcmp(path, path_cwd))
					error("%s\n%s\"%s\"\n%s\"%s\"\n",
						"Returned current working directory incorrect.",
						"Expected:	",
						path,
						"Obtained:	",
						path_cwd);
			finis
		}

		cleanup("Remove test directory.");
		start
			Zchmod(path, S_IWUSR | S_IRUSR | S_IXUSR);
			Zchdir("..");
			Zchmod(path, PROT_ALL);
			Zrmdir(path);
		finis
	finis

	done();
}
