#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>
#include	<Zdirent.h>

#include	<sv_env.h>
#include	<sv_errno.h>


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	int		open_max, i;
	

	setup(E_OPENDIR);
	funct(E_OPENDIR);

	assertion(22, BASE);
	start
		testing("Search permission is denied for pathname component.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_srch.d/test1");

			expecting(NULL);
			expecting(EACCES);
			Zopendir(path);
		finis
	finis

	assertion(23, BASE);
	start
		testing("Read permission is denied for the directory named.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_read.d");

			expecting(NULL);
			expecting(EACCES);
			Zopendir(path);
		finis
	finis

	if(tc_name_max()) {
		assertion(24, BASE);
		start
			e_NO_TRUNC(E_OPENDIR);
		finis
	}
	else
		assertion(24, NOT_TESTABLE);

	if(!tc_name_max()) {
		assertion(25, BASE);
		start
			e_NO_TRUNC(E_OPENDIR);
		finis
	}
	else
		assertion(25, NOT_TESTABLE);

	assertion(26, BASE);
	start
		e_ENAMETOOLONG(E_OPENDIR);
	finis

	assertion(27, BASE);
	start
		testing("Directory name does not exist.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "path.d/no_exist");

			expecting(NULL);
			expecting(ENOENT);
			Zopendir(path);
		finis
	finis

	assertion(28, BASE);
	start
		testing("Argument dirname points to an empty string.");
		start
			expecting(NULL);
			expecting(ENOENT);
			Zopendir("");
		finis
	finis

	assertion(29, BASE);
	start
		testing("Component of dirname is not a directory.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_dir/test1");

			expecting(NULL);
			expecting(ENOTDIR);
			Zopendir(path);
		finis
	finis

	if(get_open_max() > PCTS_OPEN_MAX) {
		assertion(30, BASE);
		start
			open_max = g_open_max();	/* Get value for {OPEN_MAX} */

			prep("Consume {PCTS_OPEN_MAX} -1 file descriptors.");
			start
						/*	Close all file descriptors except 0, 1 and 2. */
				for(i=3; i<open_max; i++)
					close(i);

				Zstrcpy(path, temp_path());
				Zstrcat(path, "fill_up");
					for(i=3; i<(PCTS_OPEN_MAX -1); i++)
						(void) Zcreat(path, PROT_ALL);
			finis

			testing("Call opendir() to open the {PCTS_OPEN_MAX}th file.");
			start
				Zstrcpy(path, temp_path());
				path[strlen(path) -1] = '\000';	/* Delete trailing '/'. */
				Zopendir(path);
			finis

			cleanup("Close all file descriptors opened except 0, 1 and 2.");
			start
				for(i=3; i<PCTS_OPEN_MAX; i++)
					close(i);
			finis
		finis
	}
	else
		assertion(30, NOT_TESTABLE);

	if(get_open_max() <= PCTS_OPEN_MAX) {
		assertion(31, BASE);
		start
			if(EMFILE_OPENDIR) {
			  if(PCD_DIR_TYPE == TRUE) {
				open_max = g_open_max();	/* Get value for {OPEN_MAX} */
	
				prep("Consume {OPEN_MAX} file descriptors.");
				start
							/*	Close all file descriptors except 0, 1 and 2. */
					for(i=3; i<open_max; i++)
						close(i);
	
					Zstrcpy(path, temp_path());
					Zstrcat(path, "fill_up");
						for(i=3; i<(open_max); i++)
							(void) Zcreat(path, PROT_ALL);
				finis
	
				testing("Call opendir() to open the {OPEN_MAX} +1 file.");
				start
					Zstrcpy(path, temp_path());
					path[strlen(path) -1] = '\000';	/* Delete trailing '/'. */
					expecting(NULL);
					expecting(EMFILE);
					Zopendir(path);
				finis
	
				cleanup("Close all file descriptors except 0, 1 and 2.");
				start
					for(i=3; i<open_max; i++)
						close(i);
				finis
			  }
			  else
				not_implemented("{PCD_DIR_TYPE} of TRUE");
			}
			else
				not_implemented("[EMFILE] detection for opendir()");
		finis
	}
	else
		assertion(31, NOT_TESTABLE);


								/*	FIPS 151-2 requires {PCD_DIR_TYPE} be
									documented if its conditional feature
									is supported.
								*/
	assertion(32, NOT_APPLICABLE);

	assertion(33, EXTENDED);
	
	assertion(34, EXTENDED);
	assertion(35, EXTENDED);
	
	done();
}
