#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>
#include	<Zdirent.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	DIRNAME			"5.5.3_4.d"
#define	DIRNAME2		"5.5.3_4.d2"
#define	DIRNAME_NEW		"5.5.3_4.dn"
#define	FILENAME		"5.5.3_4"
#define	FILENAME_NEW	"5.5.3_4_new"

static char	*file_names[] = {
							"ABCDEFGHIJLKM",
							"NOPQRSTUVWXYZ",
							"abcdefghijlkm",
							"nopqrstuvwxyz",
							"0123456789._-"
						   };

#define	INITIAL_PATHNAME_ASS_NUM	4

int main(void)
{
	int		err_ass;
	int		ass_num = INITIAL_PATHNAME_ASS_NUM;
	struct	stat st_bf1, st_bf2;
	char	path_cwd[_POSIX_PATH_MAX +1], path_ref[_POSIX_PATH_MAX +1];

	setup(E_RENAME);
	funct(E_RENAME);

	assertion(ass_num, BASE);
	start
		prep("Change current working directory to \"../tmp/%s.d\".",
									element[(int) E_RENAME].e_name);
		prep("Create known directory entries and files in working directory.");
		start
			exit_on(ERROR);
			Zstrcpy(path_cwd, temp_path());
			path_cwd[strlen(path_cwd) -1] = '\000'; /* delete trailing '/' */
			Zchdir(path_cwd);
			Zgetcwd(path_cwd, _POSIX_PATH_MAX +1);
			Zclose(Zcreat(FILENAME, S_IRWXU));

			Zmkdir(DIRNAME, S_IRWXU);
			sprintf(path_ref, "%s/%s", DIRNAME, FILENAME);
			Zclose(Zcreat(path_ref, S_IRWXU));
			Zmkdir(DIRNAME2, S_IRWXU);

										/*
												   Working_Directory
												_________________________
												  |         |         |
												  |         |         |
											   DIRNAME   FILENAME  DIRNAME2
											      |
											   FILENAME
										*/
		finis

		testing("When the first filename component of the old");
		testing("argument is \".\", and the pathname does not begin with");
		testing("a slash, then the pathname is resolved by locating");
		testing("the second filename component in the current working");
		testing("directory.");
		start
			Zstat(FILENAME, &st_bf1);
			sprintf(path_ref, "%s/%s", ".", FILENAME);
			Zrename(path_ref, FILENAME_NEW);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zrename(FILENAME_NEW, FILENAME);
		finis
	finis

	assertion(++ass_num, EXTENDED);
	assertion(++ass_num, EXTENDED);

	assertion(++ass_num, BASE);
	start
		testing("Old argument points to the string beginning");
		testing("with a \"/\".");
		start
			Zstat(FILENAME, &st_bf1);
			sprintf(path_ref, "%s/%s", path_cwd, FILENAME);
			Zrename(path_ref, FILENAME_NEW);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zrename(FILENAME_NEW, FILENAME);
		finis

		testing("Old argument points to the string beginning");
		testing("with \"///\".");
		start
			Zstat(FILENAME, &st_bf1);
			sprintf(path_ref, "//%s/%s", path_cwd, FILENAME);
			Zrename(path_ref, FILENAME_NEW);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zrename(FILENAME_NEW, FILENAME);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("First filename component of the old argument is \"..\".");
		start
			Zchdir(DIRNAME);
			Zstat(FILENAME, &st_bf1);

			sprintf(path_ref, "../%s/%s", DIRNAME, FILENAME);
			Zrename(path_ref, FILENAME_NEW);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zrename(FILENAME_NEW, FILENAME);
			Zchdir(path_cwd);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("Filename argument points to the string \"F1/\" and");
		testing("F1 is a directory.");
		start
			Zstat(DIRNAME, &st_bf1);

			sprintf(path_ref, "%s/%s", DIRNAME, "/");
			Zrename(path_ref, DIRNAME_NEW);
			Zstat(DIRNAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zrename(DIRNAME_NEW, DIRNAME);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("Filename argument points to the string \"F1//\" and");
		testing("F1 is a directory.");
		start
			Zstat(DIRNAME, &st_bf1);

			sprintf(path_ref, "%s/%s", DIRNAME, "//");
			Zrename(path_ref, DIRNAME_NEW);
			Zstat(DIRNAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zrename(DIRNAME_NEW, DIRNAME);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("Old argument points to the string \"F1/F2\".");
		start
			Zchdir(DIRNAME);
			Zstat(FILENAME, &st_bf1);

			Zchdir(path_cwd);
			sprintf(path_ref, "%s/%s", DIRNAME, FILENAME);
			Zrename(path_ref, FILENAME_NEW);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zunlink(FILENAME_NEW);
			sprintf(path_ref, "%s/%s", DIRNAME, FILENAME);
			Zclose(Zcreat(path_ref, S_IRWXU));
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("Old argument points to the string \"F1/./F2\".");
		start
			Zchdir(DIRNAME);
			Zstat(FILENAME, &st_bf1);

			Zchdir(path_cwd);
			sprintf(path_ref, "%s/./%s", DIRNAME, FILENAME);
			Zrename(path_ref, FILENAME_NEW);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zunlink(FILENAME_NEW);
			sprintf(path_ref, "%s/%s", DIRNAME, FILENAME);
			Zclose(Zcreat(path_ref, S_IRWXU));
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("Old argument points to the string \"F1/../F1/F2\".");
		start
			Zchdir(DIRNAME);
			Zstat(FILENAME, &st_bf1);

			Zchdir(path_cwd);
			sprintf(path_ref, "%s/../%s/%s", DIRNAME, DIRNAME, FILENAME);
			Zrename(path_ref, FILENAME_NEW);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zunlink(FILENAME_NEW);
			sprintf(path_ref, "%s/%s", DIRNAME, FILENAME);
			Zclose(Zcreat(path_ref, S_IRWXU));
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("Old argument points to the string \"F1//F2\".");
		start
			Zchdir(DIRNAME);
			Zstat(FILENAME, &st_bf1);

			Zchdir(path_cwd);
			sprintf(path_ref, "%s//%s", DIRNAME, FILENAME);
			Zrename(path_ref, FILENAME_NEW);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zunlink(FILENAME_NEW);
			sprintf(path_ref, "%s/%s", DIRNAME, FILENAME);
			Zclose(Zcreat(path_ref, S_IRWXU));
		finis
	finis

	if(pathconf(DIRNAME, _PC_NO_TRUNC) == (long) -1) {
		assertion(++ass_num, BASE);
		start
			testing("Old component is a string of more than {NAME_MAX}");
			testing("bytes in a directory for which {_POSIX_NO_TRUNC} is not");
			testing("supported.");
			start
				error("{_POSIX_NO_TRUNC} not supported.");
			finis
		finis
	}
	else
		assertion(++ass_num, NOT_APPLICABLE);

	assertion(++ass_num, BASE);
	start
		int	i;

		err_ass = 0;
		for(i=0; i<5; i++) {
			testing("Old argument of \"%s\" is supported and",
											file_names[i]);
			testing("the unique identity of upper and lower case");
			testing("letters are retained.");
			start
				Zcreat(file_names[i], PROT_ALL);
				Zstat(file_names[i], &st_bf1);
				Zrename(file_names[i], FILENAME_NEW);
				Zstat(FILENAME_NEW, &st_bf2);
				if(st_bf1.st_ino != st_bf2.st_ino) {
					error("%s\n%s%lu.\n%s%lu.\n",
							"File inode not expected inode.",
							"Expected inode of file to be: ",
							(unsigned long) st_bf1.st_ino,
							"Actual inode of file is: ",
							(unsigned long) st_bf2.st_ino);
					err_ass++;
				}

									/* Setup proper initialization files. */
				Zunlink(FILENAME_NEW);
			finis
		}
	finis

	assertion(++ass_num, BASE);
	start
		testing("Old argument retains the unique identity of its upper");
		testing("and lower case letters.");
		start
			if(err_ass)
				error("See previous assertion for specifics of failure.");
		finis
	finis

								/* Pathname tests for argument "new". */

	assertion(++ass_num, BASE);
	start
		testing("When the first filename component of the new");
		testing("argument is \".\", and the pathname does not begin with");
		testing("a slash, then the pathname is resolved by locating");
		testing("the second filename component in the current working");
		testing("directory.");
		start
			Zstat(FILENAME, &st_bf1);
			sprintf(path_ref, "%s/%s", ".", FILENAME_NEW);
			Zrename(FILENAME, path_ref);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zrename(FILENAME_NEW, FILENAME);
		finis
	finis

	assertion(++ass_num, EXTENDED);
	assertion(++ass_num, EXTENDED);

	assertion(++ass_num, BASE);
	start
		testing("New argument points to the string beginning");
		testing("with a \"/\".");
		start
			Zstat(FILENAME, &st_bf1);
			sprintf(path_ref, "%s/%s", path_cwd, FILENAME_NEW);
			Zrename(FILENAME, path_ref);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zrename(FILENAME_NEW, FILENAME);
		finis

		testing("New argument points to the string beginning");
		testing("with \"///\".");
		start
			Zstat(FILENAME, &st_bf1);
			sprintf(path_ref, "//%s/%s", path_cwd, FILENAME_NEW);
			Zrename(FILENAME, path_ref);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zrename(FILENAME_NEW, FILENAME);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("First filename component of the new argument is \"..\".");
		start
			Zchdir(DIRNAME);
			Zstat(FILENAME, &st_bf1);

			sprintf(path_ref, "../%s/%s", DIRNAME, FILENAME_NEW);
			Zrename(FILENAME, path_ref);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zrename(FILENAME_NEW, FILENAME);
			Zchdir(path_cwd);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("New argument points to the string \"F1/\" and");
		testing("F1 is an empty directory.");
		start
			Zstat(DIRNAME, &st_bf1);

			sprintf(path_ref, "%s%s", DIRNAME2, "/");
			Zrename(DIRNAME, path_ref);
			Zstat(DIRNAME2, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zrename(DIRNAME2, DIRNAME);
			Zmkdir(DIRNAME2, S_IRWXU);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("New argument points to the string \"F1//\" and");
		testing("F1 is an empty directory.");
		start
			Zstat(DIRNAME, &st_bf1);

			sprintf(path_ref, "%s%s", DIRNAME2, "//");
			Zrename(DIRNAME, path_ref);
			Zstat(DIRNAME2, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zrename(DIRNAME2, DIRNAME);
			Zmkdir(DIRNAME2, S_IRWXU);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("New argument points to the string \"F1/F2\".");
		start
			Zstat(FILENAME, &st_bf1);

			sprintf(path_ref, "%s/%s", DIRNAME, FILENAME_NEW);
			Zrename(FILENAME, path_ref);
			Zchdir(DIRNAME);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zunlink(FILENAME_NEW);
			Zchdir(path_cwd);
			Zclose(Zcreat(FILENAME, S_IRWXU));
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("New argument points to the string \"F1/./F2\".");
		start
			Zstat(FILENAME, &st_bf1);

			sprintf(path_ref, "%s/./%s", DIRNAME, FILENAME_NEW);
			Zrename(FILENAME, path_ref);
			Zchdir(DIRNAME);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zunlink(FILENAME_NEW);
			Zchdir(path_cwd);
			Zclose(Zcreat(FILENAME, S_IRWXU));
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("New argument points to the string \"F1/../F1/F2\".");
		start
			Zstat(FILENAME, &st_bf1);

			sprintf(path_ref, "%s/../%s/%s", DIRNAME, DIRNAME, FILENAME_NEW);
			Zrename(FILENAME, path_ref);
			Zchdir(DIRNAME);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zunlink(FILENAME_NEW);
			Zchdir(path_cwd);
			Zclose(Zcreat(FILENAME, S_IRWXU));
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("New argument points to the string \"F1//F2\".");
		start
			Zstat(FILENAME, &st_bf1);

			sprintf(path_ref, "%s//%s", DIRNAME, FILENAME_NEW);
			Zrename(FILENAME, path_ref);
			Zchdir(DIRNAME);
			Zstat(FILENAME_NEW, &st_bf2);
			if(st_bf1.st_ino != st_bf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_bf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_bf2.st_ino);

									/* Setup proper initialization files. */
			Zunlink(FILENAME_NEW);
			Zchdir(path_cwd);
			Zclose(Zcreat(FILENAME, S_IRWXU));
		finis
	finis

	if(pathconf(DIRNAME, _PC_NO_TRUNC) == (long) -1) {
		assertion(++ass_num, BASE);
		start
			testing("New component is a string of more than {NAME_MAX}");
			testing("bytes in a directory for which {_POSIX_NO_TRUNC} is not");
			testing("supported.");
			start
				error("{_POSIX_NO_TRUNC} not supported.");
			finis
		finis
	}
	else
		assertion(++ass_num, NOT_APPLICABLE);

	assertion(++ass_num, BASE);
	start
		int	i;

		err_ass = 0;
		for(i=0; i<5; i++) {
			testing("New argument of \"%s\" is supported and", file_names[i]);
			testing("the unique identity of upper and lower case");
			testing("letters are retained.");
			start
				Zstat(FILENAME, &st_bf1);
				Zrename(FILENAME, file_names[i]);
				Zstat(file_names[i], &st_bf2);
				if(st_bf1.st_ino != st_bf2.st_ino) {
					error("%s\n%s%lu.\n%s%lu.\n",
							"File inode not expected inode.",
							"Expected inode of file to be: ",
							(unsigned long) st_bf1.st_ino,
							"Actual inode of file is: ",
							(unsigned long) st_bf2.st_ino);
					err_ass++;
				}

									/* Setup proper initialization files. */
				Zrename(file_names[i], FILENAME);
			finis
		}
	finis

	assertion(++ass_num, BASE);
	start
		testing("New retains the unique identity of its upper and lower");
		testing("case letters.");
		start
			if(err_ass)
				error("See previous assertion for specifics of failure.");
		finis
	finis

	done();
}
