#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<sys/Zstat.h>
#include	<Zdirent.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME "5.1.2c_04.d"

int main(void)
{
	DIR		*dirp;
	struct	dirent	*dirent;
	char	path[_POSIX_PATH_MAX +1], path2[_POSIX_PATH_MAX +1];

	setup(E_REWINDDIR);
	funct(E_REWINDDIR);

	assertion(4, BASE);
	start
		break_on(ERROR);
		prep("Establish entries in a test directory.");
		start
			exit_on(ERROR);
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			Zmkdir(path, PROT_ALL);

			Zstrcpy(path2, path);
			Zstrcat(path2, "/First");
			Zcreat(path2, PROT_ALL);

			Zstrcpy(path2, path);
			Zstrcat(path2, "/Second");
			Zcreat(path2, PROT_ALL);
		finis

		prep("Open the test directory and read the first test entry.");
		start
			dirp = Zopendir(path);

			dirent = Zreaddir(dirp);
			Zstrcpy(path2, dirent->d_name);
			while(*(dirent->d_name) == '.') 
				dirent = Zreaddir(dirp);
			if(strcmp(dirent->d_name, "First"))
				error ("%s\n%s%s\n%s\"%s\"\n",
							"Entry incorrect.\"",
							"Expected: ",
							"First",
							"Actual:   ",
							dirent->d_name);
		finis

		prep("Rewind directory stream.");
		start
			Zrewinddir(dirp);
		finis

		testing("Position of directory stream pointer at first entry.");
		start
			dirent = Zreaddir(dirp);
			if(strcmp(path2, dirent->d_name))
				error("%s\n%s\n%s\"%s\"\n",
					"Entry incorrect.\"",
					"Expected: ",
					path2,
					"Actual:	",
					dirent->d_name);
		finis

		cleanup("Close directory stream.");
		start
			Zclosedir(dirp);
		finis
	finis

	assertion(5, BASE);
	start
		prep("Open the test directory again.");
		start
			dirp = Zopendir(path);
		finis

		prep("Read again the first test entry.");
		start
			dirent = Zreaddir(dirp);
		finis

		testing("Same entry obtained as when directory was rewound.");
		start
			if(strcmp(path2, dirent->d_name))
				error("%s\n%s\"%s\"\n%s\"%s\"\n",
					"Entry incorrect.\"",
					"Expected: ",
					path2,
					"Actual: ",
					dirent->d_name);
		finis
	finis

	cleanup("Remove files and directory created by this module.");
	start
							/*	In case rewinddir() also exists as a macro.	*/
		Zstrcpy(path, temp_path());
		Zstrcat(path, FILENAME);

		Zstrcpy(path2, path);
		Zstrcat(path2, "/First");
		Zunlink(path2);

		Zstrcpy(path2, path);
		Zstrcat(path2, "/Second");
		Zunlink(path2);

		Zrmdir(path);
	finis

	done();
}
