#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>


int main(void)
{
	setup(E_DUP);
	funct(E_DUP);

	assertion(5, BASE);
	start
		prep("Ensure file descriptor is closed.");
		start
			close(3);
		finis

		testing("Call to dup() returns -1 and sets errno to EBADF for invalid");
		testing("file descriptor.");
		start
			expecting(-1);
			expecting(EBADF);
			Zdup(3);
		finis
	finis

	assertion(6, BASE);
	start
		int		open_max, topen_max, i;
		char	path[_POSIX_PATH_MAX +1];
		int 	fildes;


		exit_on(ERROR);

		open_max = g_open_max();	/* Get value for {OPEN_MAX} */
									/* Get testable value for {OPEN_MAX} */
		topen_max = (open_max <= PCTS_OPEN_MAX) ? open_max : PCTS_OPEN_MAX;

		prep("Close all file descriptors except 0, 1 and 2.");
		start
			for(i=3; i<topen_max; i++)
				(void) close(i);
		finis

		prep("Initialize a path name.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "fill_up");
		finis

		if(open_max <= PCTS_OPEN_MAX) {
			prep("{OPEN_MAX} equal to {PCTS_OPEN_MAX}.");
			prep("Consume all available file descriptors.");
			start
				for(i=3; i<open_max; i++)
					fildes = Zcreat(path, PROT_ALL);
			finis

			testing("Call dup() when {OPEN_MAX} file descriptors are in use.");
			start
				expecting(-1);
				expecting(EMFILE);
				(void) Zdup(fildes);
			finis
		}
		else {
			prep("Testing for {PCTS_OPEN_MAX} < {OPEN_MAX}.");
			prep("Consume PCTS_OPEN_MAX -1 file descriptors."); 
			start
				for(i=3; i<(topen_max -1); i++)
					fildes = Zcreat(path, PROT_ALL);
			finis

			testing("dup() on the {PCTS_OPEN_MAX} -1 file descriptor.");
			start
				expecting(SUCCESS);
				(void) Zdup(fildes);
			finis
		}

		cleanup("Close all file descriptors except 0, 1 and 2.");
		start
			for(i=3; i<topen_max; i++)
				(void) close(i);
		finis
	finis

	done();
}
