#include	<pcts_ass.h>

#include	<sys/types.h>
#include	<fcntl.h>

#include	<sv_env.h>

struct	open_flags {
		const char	*name;
		const unsigned long	value;
		} o_flgs[] = {
			"F_DUPFD",		F_DUPFD,
			"F_GETFD",		F_GETFD,
			"F_GETLK",		F_GETLK,
			"F_SETFD",		F_SETFD,
			"F_GETFL",		F_GETFL,
			"F_SETFL",		F_SETFL,
			"F_SETLK",		F_SETLK,
			"F_SETLKW",		F_SETLKW,
	};
#define	ITEMS_O_FLAGS	(sizeof(o_flgs)/sizeof(o_flgs[0]))

struct	open_flags f_lcks[] = {
			"F_RDLCK",		F_RDLCK,
			"F_UNLCK",		F_UNLCK,
			"F_WRLCK",		F_WRLCK,
	};
#define	ITEMS_F_LCKS	(sizeof(f_lcks)/sizeof(f_lcks[0]))

struct	open_flags op_flags[] = {
			"O_RDONLY",		O_RDONLY,
			"O_WRONLY",		O_WRONLY,
			"O_RDWR",		O_RDWR,
	};
#define	ITEMS_OP_FLAGS	(sizeof(op_flags)/sizeof(op_flags[0]))

struct	of_flgs {
		const char	*name;
		const unsigned long	mask;
		} of_flags[] = {
			"O_ACCMODE",	O_ACCMODE,
			"O_APPEND",		O_APPEND,
			"O_CREAT",		O_CREAT,
			"O_EXCL",		O_EXCL,
			"O_NONBLOCK",	O_NONBLOCK,
			"O_NOCTTY",		O_NOCTTY,
			"O_TRUNC",		O_TRUNC,
	};
#define	ITEMS_OF_FLAGS	(sizeof(of_flags)/sizeof(of_flags[0]))


int main(void)
{
	setup(E_FCNTL_H);
	funct(E_FCNTL_H);

	continue_on(ERROR);

	assertion(1, BASE);
	start
		testing("When header <fcntl.h> is included, the symbolic constants");
		testing("O_CREAT, O_EXCL, O_TRUNC, O_NOCTTY, O_APPEND, O_NONBLOCK");
		testing("O_RDONLY, O_RDWR, O_WRONLY, and O_ACCMODE are defined.");
		start
#ifndef	O_CREAT
		 error("O_CREAT is not defined.");
#endif
#ifndef	O_EXCL
		 error("O_EXCL is not defined.");
#endif
#ifndef	O_TRUNC
		 error("O_TRUNC is not defined.");
#endif
#ifndef	O_NOCTTY
		 error("O_NOCTTY is not defined.");
#endif
#ifndef	O_APPEND
		 error("O_APPEND is not defined.");
#endif
#ifndef	O_NONBLOCK
		 error("O_NONBLOCK is not defined.");
#endif
#ifndef	O_RDONLY
		 error("O_RDONLY is not defined.");
#endif
#ifndef	O_RDWR
		 error("O_RDWR is not defined.");
#endif
#ifndef	O_WRONLY
		 error("O_WRONLY is not defined.");
#endif
#ifndef	O_ACCMODE
		 error("O_ACCMODE is not defined.");
#endif
		finis
	finis

	assertion(2, BASE);
	start
		testing("When header <fcntl.h> is included, the symbolic constants");
		testing("F_DUPFD, F_GETFD, F_GETLK, F_SETFD, F_GETFL, F_SETFL,");
		testing("F_SETLK, and F_SETLKW are defined.");
		start
#ifndef	F_DUPFD
		 error("F_DUPFD is not defined.");
#endif
#ifndef	F_GETFD
		 error("F_GETFD is not defined.");
#endif
#ifndef	F_GETLK
		 error("F_GETLK is not defined.");
#endif
#ifndef	F_SETFD
		 error("F_SETFD is not defined.");
#endif
#ifndef	F_GETFL
		 error("F_GETFL is not defined.");
#endif
#ifndef	F_SETFL
		 error("F_SETFL is not defined.");
#endif
#ifndef	F_SETLK
		 error("F_SETLK is not defined.");
#endif
#ifndef	F_SETLKW
		 error("F_SETLKW is not defined.");
#endif
		finis

		testing("The symbolic constants F_DUPFD, F_GETFD, F_GETLK, F_SETFD,");
		testing("F_GETFL, F_SETFL, F_SETLK, and F_SETLKW have unique values.");
		start
			UNIQUE_VALUES(o_flgs, ITEMS_O_FLAGS);
		finis
	finis

	assertion(3, BASE);
	start
		testing("When header <fcntl.h> is included, the symbolic constant");
		testing("FD_CLOEXEC is defined.");
		start
#ifndef	FD_CLOEXEC
		 error("FD_CLOEXEC is not defined.");
#endif
		finis
	finis

	assertion(4, BASE);
	start
		testing("When header <fcntl.h> is included, the symbolic constants");
		testing("F_RDLCK, F_UNLCK, and F_WRLCK are defined.");
		start
#ifndef	F_RDLCK
		 error("F_RDLCK is not defined.");
#endif
#ifndef	F_UNLCK
		 error("F_UNLCK is not defined.");
#endif
#ifndef	F_WRLCK
		 error("F_WRLCK is not defined.");
#endif
		finis

		testing("The symbolic constants F_DUPFD, F_GETFD, F_GETLK, F_SETFD,");
		testing("F_RDLCK, F_UNLCK, and F_WRLCK have unique values.");
		start
			UNIQUE_VALUES(f_lcks, ITEMS_F_LCKS);
		finis
	finis

	assertion(5, BASE);
	start
		testing("When header <fcntl.h> is included, the symbolic constants");
		testing("O_RDONLY, O_WRONLY, and O_RDWR are defined.");
		start
#ifndef	O_RDONLY
		 error("O_RDONLY is not defined.");
#endif
#ifndef	O_WRONLY
		 error("O_WRONLY is not defined.");
#endif
#ifndef	O_RDWR
		 error("O_RDWR is not defined.");
#endif
		finis

		testing("When header <fcntl.h> is included, the symbolic constants");
		testing("O_RDONLY, O_WRONLY, and O_RDWR are unique values.");
		start
			UNIQUE_VALUES(op_flags, ITEMS_OP_FLAGS);
		finis
	finis

	assertion(6, BASE);
	start
		testing("When header <fcntl.h> is included, the symbolic constants");
		testing("O_ACCMODE, O_APPEND, O_CREAT, O_EXCL, O_NONBLOCK,");
		testing("O_NOCTTY, and O_TRUNC are defined.");
		start
#ifndef	O_ACCMODE
		 error("O_ACCMODE is not defined.");
#endif
#ifndef	O_APPEND
		 error("O_APPEND is not defined.");
#endif
#ifndef	O_CREAT
		 error("O_CREAT is not defined.");
#endif
#ifndef	O_EXCL
		 error("O_EXCL is not defined.");
#endif
#ifndef	O_NONBLOCK
		 error("O_NONBLOCK is not defined.");
#endif
#ifndef	O_NOCTTY
		 error("O_NOCTTY is not defined.");
#endif
#ifndef	O_TRUNC
		 error("O_TRUNC is not defined.");
#endif
		finis

		testing("When header <fcntl.h> is included, the symbolic constants");
		testing("O_ACCMODE, O_APPEND, O_CREAT, O_EXCL, O_NONBLOCK,");
		testing("O_NOCTTY, and O_TRUNC are bitwise discrete.");
		start
			/*	A set of values is bitwise discrete if the set of
				values obtained by logically oring the members of each
				subset, of the set, is a set of unique integral values.
			*/
			BITWISE_DISTINCT(of_flags, ITEMS_OF_FLAGS)
		finis
	finis

	assertion(7, BASE);
	start
		continue_on(ERROR);
		testing("When header <fcntl.h> is included, the symbolic constant");
		testing("O_ACCMODE, is a mask for O_RDONLY, O_RDWR, and O_WRONLY.");
		start
			if((O_ACCMODE & O_RDONLY) != O_RDONLY)
				error("O_ACCMODE not a mask for O_RDONLY\n");
			if((O_ACCMODE & O_RDWR) != O_RDWR)
				error("O_ACCMODE not a mask for O_RDWR\n");
			if((O_ACCMODE & O_WRONLY) != O_WRONLY)
				error("O_ACCMODE not a mask for O_WRONLY\n");
		finis
	finis

	done();
}
