#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

#define FILENAME "6.4.1_24"
#define	String	"Ten bottles of beer on the wall"
#define	Strlen	(sizeof(String) -1)


int main(void)
{
	pid_t	pid;
	char	path[_POSIX_PATH_MAX +1];
	int 	fd;
	char	inbuf[Strlen +1];
	time_t	s_time;

	setup(E_READ);
	funct(E_READ);

	exit_on(ERROR);

	assertion(24, BASE);
	start
		prep("Create a file for testing.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			fd = Zopen(path,(O_RDWR | O_CREAT | O_TRUNC), PROT_ALL);
			expecting(Strlen);
			Zwrite(fd, String, Strlen);
			Zclose(fd);
		finis

		FORK
			testing("A read() of more than zero bytes marks for update the");
			testing("\"st_atime\" time-related field.");
			start
				fd = Zopen(path, O_RDONLY);
				Ztime(&s_time);				/* Obtain minimum reference time. */
				dt_secs(TRF_DELAY);			/* Delay a fixed interval.	*/
				expecting(Strlen);
				Zread(fd, inbuf, Strlen);
				trf_ck(CHK_ATIME, TRUE, s_time, fd, NO_PATH);
			finis
		KROF
	finis

	assertion(25, BASE);
	start
		FORK
			testing("A read() of zero bytes does not mark for update the");
			testing("\"st_atime\" time-related field.");
			start
				fd = Zopen(path, O_RDONLY);
				Ztime(&s_time);				/* Obtain minimum reference time. */
				dt_secs(TRF_DELAY);			/* Delay a fixed interval.	*/
				expecting(0);
				Zread(fd, inbuf, 0);
				trf_ck(CHK_ATIME, FALSE, s_time, fd, NO_PATH);
			finis
		KROF
	finis

	assertion(26, BASE);
	start
		FORK
			testing("When nbyte greater than zero, a read() of zero bytes");
			testing("marks for update the \"st_atime\" time-related field.");
			start
				fd = Zopen(path, O_RDONLY);
				Zlseek(fd,(off_t)0, SEEK_END);
				Ztime(&s_time);				/* Obtain minimum reference time. */
				dt_secs(TRF_DELAY);			/* Delay a fixed interval.	*/
				expecting(0);
				Zread(fd, inbuf, Strlen);
				trf_ck(CHK_ATIME, TRUE, s_time, fd, NO_PATH);
			finis
		KROF
	finis

	done();
}
