#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>
#include	<locks.h>

#define FILENAME "8.1.50_06"
char	String[] = "Hello, world!";
#define	Strlen	(sizeof(String) -1)


int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	int 	fd;
	struct	flock flock;
	short	lock_typ;
	int		i;
	pid_t	pid;
	time_t	s_time;

	setup(E_EXIT);
	funct(E_EXIT);

	assertion(6, BASE);
	start
	  ENABLE_PSYNC
		prep("Create a test file.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			fd = Zopen(path, O_RDWR | O_CREAT, PROT_ALL);
			expecting(Strlen);
			Zwrite(fd, String, Strlen);
		finis

		for(lock_typ=F_RDLCK, i=0; i<2; lock_typ=F_WRLCK, i++) {
			prep("Initialize lock structure, open file, then fork() a child.");
			start
				INIT_LOCK_STRUCT(lock_typ, SEEK_SET, ZERO_OFFSET, TOTAL_FILE,
												flock);
				sv_flush ();
				pid = Zfork();
			finis
		
			if(pid == (pid_t)0) {
				prep("Have child set a lock, then delay a while.");
				start
					Zfcntl(fd, F_SETLK, &flock);
					sv_flush();
		
					SEND_PSYNC
					SET_TIMEOUT
						WAIT_PSYNCA
					CLEAR_ALARM
				finis
		
				done_e();
			}
		
			SET_TIMEOUT
				WAIT_PSYNC
			CLEAR_ALARM
			prep("Parent ensures lock is currently set on test file.");
			start
				flock.l_type = F_WRLCK;
				Zfcntl(fd, F_GETLK, &flock);
				if(flock.l_pid != pid)
					error("Child does not have lock as expected.");
				SEND_PSYNCA
			finis

			WAIT_FOR_PID(pid);
		
			testing("Parent tests lock removed when child calls exit().");
			start
				Zfcntl(fd, F_GETLK, &flock);
				if(flock.l_type != F_UNLCK)
					error("Lock being held by exited child process.");
			finis
		}
		Zclose(fd);

		prep("Create a child process.");
		start
			sv_flush ();
			pid = Zfork();
		finis
		
		if(pid == (pid_t)0) {
			prep("Establish test file for testing time-related fields when");
			prep("exit() is performed.");
			start
				sv_flush ();
				Ztime(&s_time);				/* Obtain minimum reference time. */
				expecting(sizeof(time_t));
				Zwrite(p_syn[1], (char *)&s_time, sizeof(time_t));
				dt_secs(TRF_DELAY);			/* Delay a fixed interval. */
				fd = Zopen(path, O_RDWR, PROT_ALL);
				expecting(Strlen);
				Zwrite(fd, String, Strlen);
			finis

			done_e();
		}

		prep("Obtain test file's minimum reference time from child process.");
		start
			expecting(sizeof(time_t));
			Zread(p_syn[0], (char *)&s_time, sizeof(time_t));
		finis

		testing("Call to exit() updates all time related fields marked");
		testing("for update.");
		start
			WAIT_FOR_PID(pid);
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
		finis
	  DISABLE_PSYNC
	finis

	done();
}
