#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define FILENAME "8.1.10_4"
char	String[] = "Hello, world!";
#define	Strlen	(sizeof(String) -1)


int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	FILE	*sfd;
	char	inbuf[Strlen +1];
	pid_t	pid;

	setup(E_FERROR);
	funct(E_FERROR);

	assertion(5, BASE);
	start
		prep("Create a test file with data.");
		start
			exit_on(ERROR);			/* If this block fails nothing will work. */
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w");
			expecting(Strlen);
			Zfwrite(String, sizeof(char), Strlen, sfd);
			Zfclose(sfd);
		finis

		testing("Call to ferror(stream) returns zero, when the error");
		testing("indicator associated with stream is clear.");
		start
			sfd = Zfopen(path, "r");
			expecting(Strlen);
			Zfread(inbuf, sizeof(char), Strlen, sfd);
			if(ferror(sfd) != 0)
				error("Call to ferror() returned non-zero.");
		finis
	finis

	assertion(4, BASE);
	start
		int	flags;
		int	pipfd[2];

		FORK
			prep("Establish a pipe and set the O_NONBLOCK flag.");
			prep("Call fgetc() from an empty pipe with O_NONBLOCK set.");
			start
				Zpipe(pipfd);
				flags = Zfcntl(pipfd[0], F_GETFL);
				Zfcntl(pipfd[0], F_SETFL, flags | O_NONBLOCK);
	
				sfd = Zfdopen(pipfd[0], "r");
									/*	POSIX.3.1, fgetc[05] requires error
										to be detected.  ANSI C requires
										error indicator be set.
									*/
				expecting(EOF);
				expecting(EAGAIN);
				Zfgetc(sfd);
			finis

			testing("Call to ferror(stream) returns non-zero, when the error");
			testing("indicator associated with stream is set.");
			start
				if(ferror(sfd) == 0)
					error("Call to ferror() returned zero.");
			finis
		KROF
	finis

	done();
}
