#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

#define FILENAME	"8.1.27_04"
#define	String		"DaTa\n"
#define	Strlen		(sizeof(String) -1)


int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	FILE	*sfd;
	pid_t	pid;
	time_t	s_time;

	setup(E_FPRINTF);
	funct(E_FPRINTF);

								/*	This assertion test contains code similar
									to that of fputc(). */
	assertion(4, BASE);
	start
		prep("Establish path to test file and create it.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w");
		finis

		testing("A call to fprintf() marks for update the \"st_ctime\" and");
		testing("\"st_mtime\" time-related fields of the underlying file");
		testing("when data is caused to be written.");
		testing("Call to fprintf() used in conjunction with fflush().");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			fprintf(sfd, String);
			Zfflush(sfd);
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
		finis

		testing("A call to fprintf() marks for update the \"st_ctime\" and");
		testing("\"st_mtime\" time-related fields of the underlying file");
		testing("when data is caused to be written.");
		testing("Call to fprintf() used in conjunction with fclose().");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			fprintf(sfd, String);
			Zfclose(sfd);
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
		finis

		prep("Establish path to test file and create it.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w");
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
		finis
	
		FORK
			prep("Call to fprintf() used in conjunction with exit().");
			start
				fprintf(sfd, String);
			finis
			done_e();					/* done_e() calls exit(). */
		KROF

		testing("A call to fprintf() marks for update the \"st_ctime\" and");
		testing("\"st_mtime\" time-related fields of the underlying file");
		testing("when data is caused to be written.");
		start
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
		finis
	
		prep("Establish minimum reference time.");
		prep("Catch SIGABRT signal.");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			SIGNAL(SIGABRT, sig_int);
		finis
	
		FORK
			prep("Call to fprintf() used in conjunction with abort().");
			start
				fprintf(sfd, String);
			finis
			abort();
		KROF

		testing("A call to fprintf() marks for update the \"st_ctime\" and");
		testing("\"st_mtime\" time-related fields of the underlying file");
		testing("when data is caused to be written.");
		start
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
		finis
	finis

	done();
}
