#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/* This module has the S_ISUID mode set to ROOT. */

#define	FILENAME	"8.1.18_43"
#define	FILENAME_T	"8.1.18_43t"

int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	path_t[_POSIX_PATH_MAX +1];
	FILE	*sfd;
	char	*pathm;
	pid_t	pid;
	struct	stat st_buf;
	int		i;

	setup(E_FREOPEN);
	funct(E_FREOPEN);

	if( ! PCD_READ_ONLY_FILE_SYSTEM) {
		assertion(43, BASE);
		start
			not_implemented("read-only file system");
		finis

		done();
	}
	assertion(43, BASE);
	start
		exit_on(ERROR);

		prep("Establish a test file for obtaining an open file.");
		start
			Zstrcpy(path_t, temp_path());
			Zstrcat(path_t, FILENAME_T);
			Zclose(Zcreat(path_t, PROT_ALL));
		finis

		pathm = fs_mount( MOUNT_RO, ROFS_REG_FILE );

		abstract("Ensure mounted file system gets mounted.");
		start
		  for(i=0; i<2; i++) {
			FORK
				if(i==1) {
					prep("Set effective user ID to real user ID.");
					start
						Zsetuid(getuid());
					finis
				}

				testing("%s process attempting an freopen()",
								(i==0)?"Appropriate privilege":"Ordinary user");
				testing("with the mode flag set for writing when the file");
				testing("does not exist on a read only file system.");
				testing("Path name is \"%s\".", path);
				start
					Zstrcpy(path, pathm);
					Zstrcat(path, "/" );
					Zstrcat(path, FILENAME);
	
					continue_on(ERROR);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "w", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "a", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "w+", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "w+", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "a+", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "wb", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "ab", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "wb+", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "ab+", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "w+b", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "wb+", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "a+b", sfd);
				finis
	
				testing("File \"%s\" is not created on read-only file system.",
									FILENAME);
				start
					expecting(FAILURE);
					Zaccess(path, F_OK);
				finis
	
				testing("%s process attempting an freopen()",
								(i==0)?"Appropriate privilege":"Ordinary user");
				testing("with the mode flag set for writing when the file");
				testing("does exist on a read only file system.");
				testing("Path name is \"%s\".", path);
				start
					Zstrcpy(path, pathm);
					Zstrcat(path, "/" );
					Zstrcat(path, ROFS_TESTFILE );
	
					continue_on(ERROR);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "w", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "w+", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "wb", sfd);
	
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "wb+", sfd);
		
					expecting(SUCCESS);
					sfd = Zfopen(path_t, "r");
					expecting(NULL);
					expecting(EROFS);
					Zfreopen(path, "w+b", sfd);
				finis
	
				testing("\"%s\" was not truncated on read-only file system.",
									FILENAME);
				start
					expecting(SUCCESS);
					Zstat(path, &st_buf);
					if(st_buf.st_size == 0)
						error("File was truncated.");
				finis
			KROF
		  }
		finis
	
		fs_umount(ROFS_REG_FILE);
	finis
	
	done();
}
