#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

#define FILENAME	"8.1.25_04"


int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	pid_t	pid;
	time_t	s_time;
	FILE	*sfd;

	setup(E_PERROR);
	funct(E_PERROR);

								/*	This assertion test contains code similar
									to that of fputc(). */
	assertion(4, BASE);
	start
		prep("Establish path for temporary stderr.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = freopen(path, "w", stderr);	/* Redirect stderr. */
		finis

		FORK
			testing("A call to perror() marks for update the \"st_ctime\" and");
			testing("\"st_mtime\" time-related fields of the underlying file");
			testing("associated with standard error stream when data is");
			testing("caused to be written.");
			testing("Call to perror() used in conjunction with fflush().");
			start
				Ztime(&s_time);				/* Obtain minimum reference time. */
				dt_secs(TRF_DELAY);			/* Delay a fixed interval.		*/
				perror("\tDaTa\n");
				Zfflush(sfd);
				trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
				trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
			finis
		KROF

		FORK
			testing("A call to perror() marks for update the \"st_ctime\" and");
			testing("\"st_mtime\" time-related fields of the underlying file");
			testing("associated with standard error stream when data is");
			testing("caused to be written.");
			testing("Call to perror() used in conjunction with fclose().");
			start
				Ztime(&s_time);				/* Obtain minimum reference time. */
				dt_secs(TRF_DELAY);			/* Delay a fixed interval.		*/
				perror("\tDaTa\n");
				Zfclose(sfd);
				trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
				trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
			finis
		KROF

		prep("Establish reference time.");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
		finis
	
		FORK
			prep("Call to perror() used in conjunction with exit().");
			start
				perror("DaTa\n");
			finis
			done_e();					/* done_e() calls exit(). */
		KROF

		testing("A call to perror() marks for update the \"st_ctime\" and");
		testing("\"st_mtime\" time-related fields of the underlying file");
		testing("associated with standard error stream when data is caused");
		testing("to be written.");
		start
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
		finis
	
		prep("Establish minimum reference time.");
		prep("Catch SIGABRT signal.");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			SIGNAL(SIGABRT, sig_int);
		finis
	
		FORK
			prep("Call to perror() used in conjunction with abort().");
			start
				perror("DaTa\n");
			finis
			abort();
		KROF

		testing("A call to perror() marks for update the \"st_ctime\" and");
		testing("\"st_mtime\" time-related fields of the underlying file");
		testing("associated with standard error stream when data is caused");
		testing("to be written.");
		start
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
		finis
	finis

	done();
}
