#include	<pcts.h>

#include	<locale.h>
#include	<sv_env.h>

/*	NOTE:	These tests should have an additional locale other than "C" and
			"POSIX" to test these assertions.  If the implementation does
			not provide an additional locale, then these tests are sufficient
			for this implentation since the locale will not change.
*/

extern	char **environ;
void	v_c_env(void);


int main(void)
{
					/*	null string:  Initial element is a null character. */
	char	null_string[] = {'\000'};
	char	*ret_ptr;

	setup(E_SETLOCALE);
	funct(E_SETLOCALE);

	assertion(7, BASE);
	start
		prep("Establish test environment for LC_ALL.");
		start
			if(strlen(ANOTHER_LOCALE))
				if(setlocale(LC_ALL, ANOTHER_LOCALE) == NULL)
					error("Attempting to establish locale of %s failed.",
								ANOTHER_LOCALE);

			environ[0] = (char *)0;
			put_env("LC_ALL=POSIX");
		finis

		testing("When locale is a pointer to a NULL string and the");
		testing("environment variable LC_ALL specifies a valid locale,");
		testing("then setlocale(category, locale) sets the locale for the");
		testing("requested category to the value of LC_ALL.");
		start
			setlocale(LC_ALL, null_string);
			v_c_env();
		finis
	finis

	assertion(8, BASE);
	start
		prep("Establish test environment for LC_ALL.");
		start
			environ[0] = (char *)0;
			put_env("LC_ALL=INVALID_LOCALE");
		finis

		testing("When locale is a pointer to a NULL string and the");
		testing("environment variable LC_ALL does not specify a valid locale,");
		testing("then setlocale(category, locale) returns NULL and does");
		testing("not change the locale setting.");
		start
			if((ret_ptr = setlocale(LC_ALL, null_string)) != NULL)
				error("Return from setlocale() was not NULL.");

			v_c_env();
		finis
	finis

	assertion(9, BASE);
	start
		prep("Establish test environment.");
		start
			if(strlen(ANOTHER_LOCALE))
				if(setlocale(LC_ALL, ANOTHER_LOCALE) == NULL)
					error("Attempting to establish locale of %s failed.",
								ANOTHER_LOCALE);

			environ[0] = (char *)0;
			put_env("LC_ALL=");
			put_env("LC_CTYPE=C");
			put_env("LC_COLLATE=C");
			put_env("LC_TIME=C");
			put_env("LC_NUMERIC=C");
			put_env("LC_MONETARY=C");
		finis

		testing("When category is any of LC_CTYPE, LC_COLLATE, LC_TIME,");
		testing("LC_NUMERIC, or LC_MONETARY, locale is a pointer to a NULL");
		testing("string, the environment variable LC_ALL is either not set or");
		testing("is set to a NULL string and the environment variable");
		testing("corresponding to category is set to a valid locale, then");
		testing("setlocale() sets the specified category to the value in the");
		testing("corresponding environment variable.");
		start
			setlocale(LC_CTYPE, null_string);
			setlocale(LC_COLLATE, null_string);
			setlocale(LC_TIME, null_string);
			setlocale(LC_NUMERIC, null_string);
			setlocale(LC_MONETARY, null_string);
			v_c_env();
		finis
	finis

	assertion(10, BASE);
	start
		prep("Establish test environment.");
		start
			if(setlocale(LC_ALL, "C") == NULL)
				error("Attempting to establish locale of \"C\" failed.");

			environ[0] = (char *)0;
			put_env("LC_ALL=");
			put_env("LC_CTYPE=INVALID_LOCALE");
			put_env("LC_COLLATE=INVALID_LOCALE");
			put_env("LC_TIME=INVALID_LOCALE");
			put_env("LC_NUMERIC=INVALID_LOCALE");
			put_env("LC_MONETARY=INVALID_LOCALE");
		finis

		testing("When category is any of LC_CTYPE, LC_COLLATE, LC_TIME,");
		testing("LC_NUMERIC, or LC_MONETARY, locale is a pointer to a NULL");
		testing("string, the environment variable LC_ALL is either not set or");
		testing("is set to a NULL string and the environment variable");
		testing("corresponding to category is not a NULL string and is not a");
		testing("valid locale, then setlocale() returns NULL and does not");
		testing("change the locale setting.");
		start
			if(setlocale(LC_CTYPE, null_string) != NULL)
				error("Return from setlocale(LC_CTYPE, null_string) was not NULL.");
			if(setlocale(LC_COLLATE, null_string) != NULL)
				error("Return from setlocale(LC_COLLATE, null_string) was not NULL.");
			if(setlocale(LC_TIME, null_string) != NULL)
				error("Return from setlocale(LC_TIME, null_string) was not NULL.");
			if(setlocale(LC_NUMERIC, null_string) != NULL)
				error("Return from setlocale(LC_NUMERIC, null_string) was not NULL.");
			if(setlocale(LC_MONETARY, null_string) != NULL)
				error("Return from setlocale(LC_MONETARY, null_string) was not NULL.");

			v_c_env();
		finis
	finis


	assertion(11, BASE);
	start
		prep("Establish test environment.");
		start
			if(strlen(ANOTHER_LOCALE))
				if(setlocale(LC_ALL, ANOTHER_LOCALE) == NULL)
					error("Attempting to establish locale of %s failed.",
								ANOTHER_LOCALE);

			environ[0] = (char *)0;
			put_env("LC_ALL=");
			put_env("LC_CTYPE=");
			put_env("LC_COLLATE=");
			put_env("LC_TIME=");
			put_env("LC_NUMERIC=");
			put_env("LC_MONETARY=");
			put_env("LANG=C");
		finis

		testing("When category is any of LC_CTYPE, LC_COLLATE, LC_TIME,");
		testing("LC_NUMERIC, or LC_MONETARY, locale is a pointer to a NULL");
		testing("string, the environment variable LC_ALL and the environment");
		testing("variable is either not set or set to a NULL string, and the");
		testing("environment variable LANG is set to a valid locale, then");
		testing("setlocale() sets the specified category to the value in the");
		testing("LANG environment variable.");
		start
			if(setlocale(LC_CTYPE, null_string) == NULL)
				error("Return from setlocale(LC_CTYPE, null_string) was NULL.");
			if(setlocale(LC_COLLATE, null_string) == NULL)
				error("Return from setlocale(LC_COLLATE, null_string) was NULL.");
			if(setlocale(LC_TIME, null_string) == NULL)
				error("Return from setlocale(LC_TIME, null_string) was NULL.");
			if(setlocale(LC_NUMERIC, null_string) == NULL)
				error("Return from setlocale(LC_NUMERIC, null_string) was NULL.");
			if(setlocale(LC_MONETARY, null_string) == NULL)
				error("Return from setlocale(LC_MONETARY, null_string) was NULL.");
			setlocale(LC_CTYPE, null_string);
			if(setlocale(LC_MONETARY, null_string) == NULL)
				error("Return from setlocale(LC_MONETARY, null_string) was NULL.");

			v_c_env();
		finis
	finis

	assertion(12, BASE);
	start
		prep("Establish test environment.");
		start
			if(setlocale(LC_ALL, "C") == NULL)
				error("Attempting to establish locale of \"C\" failed.");

			environ[0] = (char *)0;
			put_env("LC_ALL=");
			put_env("LC_CTYPE=INVALID_LOCALE");
			put_env("LC_COLLATE=INVALID_LOCALE");
			put_env("LC_TIME=INVALID_LOCALE");
			put_env("LC_NUMERIC=INVALID_LOCALE");
			put_env("LC_MONETARY=INVALID_LOCALE");
			put_env("LANG=INVALID_LOCALE");
		finis

		testing("When category is any of LC_CTYPE, LC_COLLATE, LC_TIME,");
		testing("LC_NUMERIC, or LC_MONETARY, locale is a pointer to a NULL");
		testing("string, the environment variable LC_ALL is either not set or");
		testing("is set to a NULL, and the environment variable");
		testing("corresponding to category is either not set or is set to a");
		testing("NULL string, and the environment variable LANG is not a");
		testing("NULL string and does not specify a valid locale, then");
		testing("setlocale() returns NULL and does not change the locale");
		testing("setting.");
		start
			if(setlocale(LC_CTYPE, null_string) != NULL)
				error("Return from setlocale(LC_CTYPE, null_string) was not NULL.");
			if(setlocale(LC_COLLATE, null_string) != NULL)
				error("Return from setlocale(LC_COLLATE, null_string) was not NULL.");
			if(setlocale(LC_TIME, null_string) != NULL)
				error("Return from setlocale(LC_TIME, null_string) was not NULL.");
			if(setlocale(LC_NUMERIC, null_string) != NULL)
				error("Return from setlocale(LC_NUMERIC, null_string) was not NULL.");
			if(setlocale(LC_MONETARY, null_string) != NULL)
				error("Return from setlocale(LC_MONETARY, null_string) was not NULL.");

			v_c_env();
		finis
	finis

	assertion(13, BASE);
	start
		prep("Establish test environment.");
		start
			if(strlen(ANOTHER_LOCALE))
				if(setlocale(LC_ALL, ANOTHER_LOCALE) == NULL)
					error("Attempting to establish locale of %s failed.",
								ANOTHER_LOCALE);

			environ[0] = (char *)0;
			put_env("LC_ALL=");
			put_env("LC_CTYPE=C");
			put_env("LC_COLLATE=C");
			put_env("LC_TIME=C");
			put_env("LC_NUMERIC=C");
			put_env("LC_MONETARY=C");
		finis

		testing("When category is LC_ALL, locale is a pointer to a NULL,");
		testing("the environment variable LC_ALL is either not set or set");
		testing("to a NULL, then for each of the environment variables");
		testing("LC_CTYPE, LC_COLLATE, LC_TIME, LC_NUMERIC, or LC_MONETARY");
		testing("which are not a NULL string and specify a valid locale,");
		testing("setlocale() sets the locale for that category to the value");
		testing("of the corresponding environment variable.");
		start
			if(setlocale(LC_ALL, null_string) == NULL)
				error("Return from setlocale(LC_ALL, null_string) was NULL.");

			v_c_env();
		finis
	finis


	assertion(14, BASE);
	start
		prep("Establish test environment.");
		start
			if(strlen(ANOTHER_LOCALE))
				if(setlocale(LC_ALL, ANOTHER_LOCALE) == NULL)
					error("Attempting to establish locale of %s failed.",
								ANOTHER_LOCALE);

			environ[0] = (char *)0;
			put_env("LC_ALL=");
			put_env("LC_CTYPE=");
			put_env("LC_COLLATE=");
			put_env("LC_TIME=");
			put_env("LC_NUMERIC=");
			put_env("LC_MONETARY=");
			put_env("LANG=C");
		finis

		testing("When category is LC_ALL, locale is a pointer to a NULL,");
		testing("the environment variable LC_ALL is either not set or set");
		testing("to a NULL and the environment variable LANG is set to a");
		testing("valid locale, then for each of the environment variables");
		testing("LC_CTYPE, LC_COLLATE, LC_TIME, LC_NUMERIC, or LC_MONETARY");
		testing("which is either not set or set to a NULL, setlocale() sets");
		testing("the locale for that category to the value of the");
		testing("corresponding environment variable LANG.");
		start
			if(setlocale(LC_ALL, null_string) == NULL)
				error("Return from setlocale(LC_ALL, null_string) was NULL.");

			v_c_env();
		finis
	finis


	assertion(15, BASE);
	start
		prep("Establish test environment.");
		start
			if(setlocale(LC_ALL, "C") == NULL)
				error("Attempting to establish locale of \"C\" failed.");

			environ[0] = (char *)0;
			put_env("LC_ALL=");
			put_env("LC_CTYPE=INVALID_LOCALE");
			put_env("LC_COLLATE=INVALID_LOCALE");
			put_env("LC_TIME=INVALID_LOCALE");
			put_env("LC_NUMERIC=INVALID_LOCALE");
			put_env("LC_MONETARY=INVALID_LOCALE");
		finis

		testing("When category is LC_ALL, locale is a pointer to a NULL,");
		testing("the environment variable LC_ALL is either not set or set");
		testing("to a NULL and any of the environment variables LC_CTYPE,");
		testing("LC_COLLATE, LC_TIME, LC_NUMERIC, or LC_MONETARY is not a");
		testing("NULL and does not specify a valid locale, setlocale()");
		testing("returns NULL and does not change the locale setting.");
		start
			if(setlocale(LC_ALL, null_string) != NULL)
				error("Return from setlocale(LC_ALL, null_string) was not NULL.");

			v_c_env();
		finis
	finis


	assertion(16, BASE);
	start
		prep("Establish test environment.");
		start
			if(setlocale(LC_ALL, "C") == NULL)
				error("Attempting to establish locale of \"C\" failed.");

			environ[0] = (char *)0;
			put_env("LC_ALL=");
			put_env("LC_CTYPE=");
			put_env("LC_COLLATE=");
			put_env("LC_TIME=");
			put_env("LC_NUMERIC=");
			put_env("LC_MONETARY=");
			put_env("LANG=INVALID_LOCALE");
		finis

		testing("When category is LC_ALL, locale is a pointer to a NULL,");
		testing("the environment variable LC_ALL is either not set or set");
		testing("to a NULL and any of the environment variables LC_CTYPE,");
		testing("LC_COLLATE, LC_TIME, LC_NUMERIC, or LC_MONETARY is either");
		testing("not set or is set to a NULL, and the environment variable");
		testing("LANG is not a NULL string and does not specify a valid");
		testing("locale, then setlocale() returns NULL and does not change");
		testing("the locale setting.");
		start
			if(setlocale(LC_ALL, null_string) != NULL)
				error("Return from setlocale(LC_ALL, null_string) was not NULL.");

			v_c_env();
		finis
	finis

	done();
}

void v_c_env()
{
	struct	lconv *l_conv;

	if((l_conv = localeconv()) == NULL)
		error("NULL pointer returned by localeconv().");

	if(strcmp(l_conv->decimal_point, "."))
		error("Element lconv.decimal_point is \"%s\" expected \".\".",
												l_conv->decimal_point);
	if(*(l_conv->thousands_sep) != '\000')
		error("Element lconv.thousands_sep is \"%s\" expected \"\".",
													l_conv->thousands_sep);
	if(*(l_conv->grouping) != '\000')
	if(!strcmp(l_conv->grouping, ""))
		error("Element lconv.grouping is \"%s\" expected \"\".",
													l_conv->grouping);
	if(*(l_conv->int_curr_symbol) != '\000')
		error("Element lconv.int_curr_symbol is \"%s\" expected \"\".",
													l_conv->int_curr_symbol);
	if(*(l_conv->currency_symbol) != '\000')
		error("Element lconv.currency_symbol is \"%s\" expected \"\".",
													l_conv->currency_symbol);
	if(*(l_conv->mon_decimal_point) != '\000')
		error("Element lconv.mon_decimal_point is \"%s\" expected \"\".",
													l_conv->mon_decimal_point);
	if(*(l_conv->mon_thousands_sep) != '\000')
		error("Element lconv.mon_thousands_sep is \"%s\" expected \"\".",
													l_conv->mon_thousands_sep);
	if(*(l_conv->mon_grouping) != '\000')
		error("Element lconv.mon_grouping is \"%s\" expected \"\".",
													l_conv->mon_grouping);
	if(*(l_conv->positive_sign) != '\000')
		error("Element lconv.positive_sign is \"%s\" expected \"\".",
													l_conv->positive_sign);
	if(*(l_conv->negative_sign) != '\000')
		error("Element lconv.negative_sign is \"%s\" expected \"\".",
													l_conv->negative_sign);
	if(l_conv->int_frac_digits != CHAR_MAX)
		error("Element lconv.int_frac_digits is \"%d\" expected \"%d\".",
										(int)l_conv->int_frac_digits, CHAR_MAX);
	if(l_conv->frac_digits != CHAR_MAX)
		error("Element lconv.frac_digits is \"%d\" expected \"%d\".",
										(int)l_conv->frac_digits, CHAR_MAX);
	if(l_conv->p_cs_precedes != CHAR_MAX)
		error("Element lconv.p_cs_precedes is \"%d\" expected \"%d\".",
										(int)l_conv->p_cs_precedes, CHAR_MAX);
	if(l_conv->p_sep_by_space != CHAR_MAX)
		error("Element lconv.p_sep_by_space is \"%d\" expected \"%d\".",
										(int)l_conv->p_sep_by_space, CHAR_MAX);
	if(l_conv->n_cs_precedes != CHAR_MAX)
		error("Element lconv.n_cs_precedes is \"%d\" expected \"%d\".",
										(int)l_conv->n_cs_precedes, CHAR_MAX);
	if(l_conv->n_sep_by_space != CHAR_MAX)
		error("Element lconv.n_sep_by_space is \"%d\" expected \"%d\".",
										(int)l_conv->n_sep_by_space, CHAR_MAX);
	if(l_conv->p_sign_posn != CHAR_MAX)
		error("Element lconv.p_sign_posn is \"%d\" expected \"%d\".",
										(int)l_conv->p_sign_posn, CHAR_MAX);
	if(l_conv->n_sign_posn != CHAR_MAX)
		error("Element lconv.n_sign_posn is \"%d\" expected \"%d\".",
										(int)l_conv->n_sign_posn, CHAR_MAX);
}
