#include	<pcts.h>

#include	<sv_env.h>

extern	char **environ;
extern	char *tzname[2];

static char	*good_tz[] = {
							"ABC", "DEF", "GHI", "JLK", "MNO",
							"PQR", "STU", "VWX", "YZz",
							"abc", "def", "ghi", "jlk", "mno",
							"pqr", "stu", "vwx", "yzZ",
							"",
						   };

static char	*bad_tz[] = {
							":AB", ",AB", "-AB", "+AB",
							"0AB", "1AB", "2AB", "3AB", "4AB",
							"5AB", "6AB", "7AB", "8AB", "9AB",
							"",
						   };
#define	Strlen	10
static	char	String[Strlen];

int	main(void)
{
	time_t	timer = 1000;
	char	tz_env[100];				/* Contains TZ environment */
	int		i;
	struct	tm *tm;

	setup(E_STRFTIME);
	funct(E_STRFTIME);

	assertion(4, BASE);
	start
		sprintf(tz_env, "TZ=dst0std");
		environ[0] = (char *)0;
		put_env(tz_env);				/* Establish TZ environment.	*/
		tm = localtime(&timer);			/* Establish "tm" structure.	*/
		for(i=0; *good_tz[i+1]; i++) {
			sprintf(tz_env, "TZ=%.*s0%.*s", strlen(good_tz[i]), good_tz[i],
										strlen(good_tz[i +1]), good_tz[i +1]);

			testing("TZ is acceptable with form: TZ=%s", getenv("TZ"));
			start
				(void) strftime(String, Strlen, "%Z", tm);
				if(strncmp(tzname[0], good_tz[i], strlen(good_tz[i])))
					error("tzname[0]: %s\nStandard designation: %.*s",
									tzname[0], strlen(good_tz[i]), good_tz[i]);
				if(strncmp(tzname[1], good_tz[i+1], strlen(good_tz[i+1])))
					error("tzname[1]: %s\nSummer designation: %.*s",
								tzname[1], strlen(good_tz[i+1]), good_tz[i+1]);
			finis
		}

		for(i=0; *bad_tz[i+1]; i++) {
			sprintf(tz_env, "TZ=%.*s0%.*s", strlen(bad_tz[i]), bad_tz[i],
										strlen(bad_tz[i +1]), bad_tz[i +1]);

			testing("TZ is unacceptable with form: TZ=%s", getenv("TZ"));
			start
				(void) strftime(String, Strlen, "%Z", tm);
				if(!strncmp(tzname[0], bad_tz[i], strlen(bad_tz[i])))
					error("tzname[0]: %s\nStandard designation: %.*s",
									tzname[0], strlen(bad_tz[i]), bad_tz[i]);
				if(!strncmp(tzname[1], bad_tz[i+1], strlen(bad_tz[i+1])))
					error("tzname[1]: %s\nSummer designation: %.*s",
								tzname[1], strlen(bad_tz[i+1]), bad_tz[i+1]);
			finis
		}
	finis

	done();
}
