#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<termios.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

char String[]	= "ctermid() check\n";
#define Strlen	(sizeof(String)-1)


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];
	pid_t	pid;
	int		tty_ctid;

	setup(E_CTERMID);
	funct(E_CTERMID);

	assertion(8, EXTENDED);

	assertion(7, BASE);
	start
		char	path_ctid[L_ctermid];
		char	*ret_ctid;

		GTI_NOT_PROVIDED_EXIT

		FORK
			prep("Acquire a controlling terminal and setup TTY lines.");
			start
				termios_prep(&tty_fildes, tty_termios_p,
									&loop_fildes, loop_termios_p);
										/* Enable SIGNALS */
				loop_termios_p->c_lflag |= ISIG;
				Ztcsetattr(loop_fildes, TCSANOW, loop_termios_p);
				Ztcflush(tty_fildes, TCIOFLUSH);
				Ztcflush(loop_fildes, TCIOFLUSH);
			finis

			prep("Ensure a controlling terminal has been established.");
			prep("Send special character INTR to all processes in");
			prep("foreground process group for which the terminal sent");
			prep("the INTR is the controlling terminal.");
			start
				SIGNAL(SIGINT, sig_int);

				sig_rcvd = 0;
				SET_ALARM(WAIT_FOR_TIME)
					WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VINTR]);
					if(sig_rcvd == 0)
						pause();
				IGNORE_ALARM

				if(sig_rcvd == 0)
					error("This process did not receive SIGINT.");
			finis

			prep("Obtain file descriptor that references controlling");
			prep("terminal from ctermid() provided info.");
			start
				ret_ctid = Zctermid(path_ctid);
				SET_ALARM(WAIT_FOR_TIME)
					tty_ctid = Zopen(path_ctid, O_RDWR);
				CLEAR_ALARM
			finis

			testing("ctermid() generates a string that when used as a");
			testing("pathname refers to the controlling terminal for the");
			testing("current process.");
			start
				SET_ALARM(2 * WAIT_FOR_TIME)
					expecting(Strlen);
					Zwrite(tty_ctid, String, Strlen);
					Ztcdrain(tty_ctid);
					SLEEP(1);
				CLEAR_ALARM

				SET_ALARM(WAIT_FOR_TIME)
					expecting(Strlen);
					Zread(loop_fildes, inbuf, sizeof(inbuf));
				CLEAR_ALARM
			finis

			testing("Length of string return in parameter \"s\" is less");
			testing("than L_ctermid bytes.");
			start
				int	len_str;

				if((len_str = Zstrlen(path_ctid)) >= L_ctermid)
					error("%s\n%s(%ld).\n%s%d.",
							"String returned by ctermid() too long.",
							"Expected length less than L_ctermid ",
							(long) L_ctermid,
							"Actual value is ",
							len_str);
			finis

			testing("Value returned by ctermid() is address of \"s\".");
			start
				if(ret_ctid != path_ctid)
					error("%s\n%s(%lu).\n%s%lu.",
							"Value returned not expected address.",
							"Expected address of \"s\" ",
							(unsigned long) path_ctid,
							"Actual value returned was ",
							(unsigned long) ret_ctid);
			finis
		KROF
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
