#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zsignal.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>


int	main(void)
{
	pid_t	pid, pgrp;

	setup(E_SETPGID);
	funct(E_SETPGID);

   					/*
              					non-session leader process
                      					|
        					____________|
        					|pid=pid_ch |
                      					|
                  					setsid()
					  					|
									setpgid(pid_ch, pgrp)
  					*/
	assertion(14,BASE);
	start
		ENABLE_PSYNC
		FORK
			prep("Fork child process.");
			start
				pid = Zfork();
			finis
	
			if(pid == (pid_t)0) {
				SEND_PSYNC
				SLEEP(WAIT_FOR_TIME);
				done();
			}

			SET_TIMEOUT
				WAIT_PSYNC
			CLEAR_ALARM

			prep("Establish parent process as a session leader.");
			start
				sv_flush();
				Zsetsid();
			finis

			testing("Call to setpgid() to set process group of child");
			testing("process in another session.");
			start
				pgrp = Zgetpgrp();
				expecting(EPERM);
				Zsetpgid(pid, pgrp);
			finis

			WAIT_FOR_PID(pid);
		KROF
		DISABLE_PSYNC
	finis

	done();
}
