#include	<pcts.h>

#include	<Zunistd.h>
#include	<Ztermios.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

int	main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	pid_t pid;

	setup(E_SETSID);
	funct(E_SETSID);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(8, BASE)
		GTI_NOT_PROVIDED_RESULT(9, BASE)
		done();
	}

	assertion(8, BASE); 
	start
		FORK
			prep("Establish this process as a process group leader.  Create");
			prep("a new session and establish a controlling terminal.");
			start
				Zsetsid();
				tty_prep(&tty_fildes, tty_termios_p);
				loop_prep(&loop_fildes, loop_termios_p);
			finis

			testing("A call of setsid() when process is already group leader.");
			start
				expecting(EPERM);
				(void) Zsetsid();
			finis

			testing("Calling process still retains its controlling terminal.");
			start
				expecting(SUCCESS);
				Ztcgetpgrp(tty_fildes);
			finis
		KROF
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	assertion(9, EXTENDED);

	done();
}
