#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>

extern	char	**environ;
static	int		e_index;

#define	FILENAME	"./3.1.2_36x"

#define	OFFSET_LENGTH	20
#define	ID_LENGTH		10
#define	FD_LENGTH		10
char	a_indx[ID_LENGTH];
char	a_offset[OFFSET_LENGTH];
char	a_fd1[FD_LENGTH];
char	a_fd2[FD_LENGTH];
char	a_fd3[FD_LENGTH];
char	a_ino[OFFSET_LENGTH];
char	a_dev[OFFSET_LENGTH];

static	char	*args[] = {
						a_indx,
						a_fd1,
						a_fd2,
						a_fd3,
						a_offset,
						a_ino,
						a_dev,
						(char *)0,
					};

int	main(int argc, char *argv[])
{
	int		fd1, fd2, fd3;
	pid_t	pid;
	off_t  offset;
	struct stat st_buf;

	e_index = atoi(*++argv);
	Zstrcpy(a_indx, *argv);
	setup(e_index);
	funct(e_index);

	assertion(36, BASE);
	start
		prep("Reset \"environ\".");
		start
			environ[0] = (char *)0;
		finis

		FORK
			prep("Create three files and set FD_CLOEXEC flag on the third.");
			start
				fd1 = temp_open("A_1", O_CREAT | O_RDWR | O_APPEND, PROT_ALL);
				fd2 = temp_creat("A_2", PROT_ALL);
				fd3 = temp_creat("A_3", PROT_ALL);
				Zfcntl(fd3, F_SETFD, FD_CLOEXEC);
			  	sprintf(a_fd1, "%d", fd1);
			  	sprintf(a_fd2, "%d", fd2);
			  	sprintf(a_fd3, "%d", fd3);
											/*	Ensure file associated with
												file descriptor is tested.
											*/
				Zfstat(fd3, &st_buf);
				sprintf(a_ino, "%lu", (unsigned long)st_buf.st_ino);
				sprintf(a_dev, "%lu", (unsigned long)st_buf.st_dev);
			finis
		
			prep("Write some data to file descriptors 1 and 2.");
			start
				Zwrite(fd1, "Hi There\n", 9);
				Zwrite(fd2, "By Now\n", 9);
			finis
	
			preparation("Retain offset of file descriptor 1.");
			start
				offset = lseek(fd1, 0, SEEK_CUR);
				sprintf(a_offset, "%lu", (unsigned long)offset);
			finis
		
			preparation("Place a F_WRLCK on file descriptor 2.");
			start
				struct flock	lock_struct;
	
				lock_struct.l_type = F_WRLCK;
				lock_struct.l_whence = SEEK_SET;
				lock_struct.l_start = 0;
				lock_struct.l_len = 0;
				Zfcntl(fd2, F_SETLK, &lock_struct);
			finis
	
			prep("Execute proper exec module.");
			start
			  sv_flush();
			  switch(e_index) {
				case E_EXECL:
					Zexecl(FILENAME, a_indx, a_fd1, a_fd2, a_fd3, a_offset,
								a_ino, a_dev, (char *)0);
					break;
				case E_EXECLE:
					Zexecle(FILENAME, a_indx, a_fd1, a_fd2, a_fd3, a_offset,
								a_ino, a_dev, (char *)0, environ);
					break;
				case E_EXECV:
	    			Zexecv(FILENAME, args);
					break;
				case E_EXECVE:
	    			Zexecve(FILENAME, args, environ);
					break;
				case E_EXECLP:
					Zexeclp(FILENAME, a_indx, a_fd1, a_fd2, a_fd3, a_offset,
								a_ino, a_dev, (char *)0);
					break;
				case E_EXECVP:
	    			Zexecvp(FILENAME, args);
					break;
				default:
					error("Bad indx \"%d\" passed.", e_index);
			  }
			finis
		KROF
	finis

	done();
}
