#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

/* This module has S_ISUID bit set to ROOT.  */


int	main(void)
{
	pid_t		pid;
	sigset_t	set;

	setup(E_KILL);
	funct(E_KILL);

	exit_on(ERROR);
	assertion(15, BASE);
	start
		ENABLE_PSYNC
		prep("Fork a child.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid ==(pid_t)0) {
			prep("Set child process IDs to BIN_UID.");
			start
				Zsetuid(BIN_UID);
			finis

			prep("Block SIGCONT signal.");
			start
				SIGNAL(SIGCONT, sig_int);
				SIGBLOCK(set, SIGCONT);
			finis

			SEND_PSYNC
			SET_TIMEOUT
				WAIT_PSYNCA
			CLEAR_ALARM

			testing("Signal SIGCONT delivered to child process.");
			start
				Zsigpending(&set);
				if( ! sigismember(&set, SIGCONT) )
					error("SIGCONT signal not delivered.");
			finis

			done();
		}

		prep("Set parent process IDs to UID.");
		start
			Zsetuid(UID);
		finis

		SET_TIMEOUT
			WAIT_PSYNC
		CLEAR_ALARM

		testing("Signal SIGCONT can be sent via kill() to a process");
		testing("irrespective of its user IDs as long as the process");
		testing("is a member of the same session.");
		start
			Zkill(pid, SIGCONT);
		finis

		SEND_PSYNCA
		WAIT_FOR_PID(pid);
		DISABLE_PSYNC
	finis

	done();
}
