#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>

int	main(void)
{
	pid_t	pid;

	setup(E_KILL);
	funct(E_KILL);

	if(PCTS_INVALID_SIGNAL == 0) {
		assertion(16, NOT_TESTABLE);
	}
	else {
		assertion(16, BASE);
		start
			FORK
				testing("Call to kill() using an invalid signal number.");
				start
					expecting(-1);
					expecting(EINVAL);
					Zkill(getpid(), PCTS_INVALID_SIGNAL_NUMBER);
				finis
			KROF
		finis
	}

	assertion(20, BASE);
	start
		pid_t	pid_used;

		FORK
			prep("Fork a child.");
			start
				sv_flush();
				pid_used = Zfork();
			finis

			if(pid_used ==(pid_t)0) {
				done();
			}
			WAIT_FOR_PID(pid_used);

			testing("Call to kill() when no process and no process group");
			testing("can be found corresponding to that specified by pid.");
			start
				expecting(-1);
				expecting(ESRCH);
				Zkill(pid_used, SIGINT);
			finis
		KROF
	finis

	done();
}
