#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<sv_sigs.h>

int	main(void)
{
	sigset_t	set;

	setup(E_SIGDELSET);
	funct(E_SIGDELSET);

	assertion(4, BASE);
	start
		int	i, st;

		prep("Initialize signal set to all members set.");
		start
			expecting((int)0);
			Zsigfillset(&set);
			for(i=0; i<NSIGS; i++) {
				st = sigismember(&set, sigs[i].sig);
				if(st == 0)
					error("Signal %s is not a member of the initialized set .",
								sigs[i].signame);
			}
		finis

		testing("Call to sigdelset() deletes signal specified from the set.");
		testing("A value of zero is returned.");
		start
			for(i=0; i<NSIGS; i++) {
		   		expecting((int)0);
		   		Zsigdelset(&set, sigs[i].sig);
				st = sigismember(&set, sigs[i].sig);
				if(st == 1)
					error("Signal %s still included in the set .",
															sigs[i].signame);
			}
		finis
	finis

	if(PCTS_INVALID_SIGNAL == 0) {
		assertion(5, NOT_TESTABLE);
	}
	else {
		assertion(5, BASE);
		start
	    	testing("Call to sigdelset() returns a value of -1 and errno");
			testing("is set to [EINVAL] when the signal number is invalid.");
	    	start
	       		expecting(-1);
	       		expecting(EINVAL);
	       		Zsigdelset(&set, PCTS_INVALID_SIGNAL_NUMBER);
	    	finis
		finis
	}

	assertion(6, EXTENDED);

    done();
}
