#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_sigs.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>


int main(void)
{
	pid_t	pid;
	int		stat_val, i;

	setup(E_SIGNAL_CON);
	funct(E_SIGNAL_CON);


	assertion(18, BASE);
	start
		prep("Fork a process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Stop the child process.");
			start
				Zkill(getpid(), SIGSTOP);
				SLEEP(WAIT_FOR_TIME);
			finis

			done();
		}

		prep("Wait for child process to stop.");
		start
			SET_ALARM(TIMEOUT)
                while(Zwaitpid(pid, &stat_val, WUNTRACED | WNOHANG) != pid)
                    ;
                if( ! WIFSTOPPED(stat_val) )
                    error("Bad value for stat_val.");
			CLEAR_ALARM
		finis

		prep("Issue SIGCONT to child process.");
		start
			Zkill(pid, SIGCONT);
		finis

		testing("Default action for SIGCONT is to continue the process.");
		start
			SET_ALARM(TIMEOUT)
				Zwaitpid(pid, &stat_val, 0);
			CLEAR_ALARM

			if( ! WIFEXITED(stat_val)) {
				Zkill(pid, SIGKILL);
				error("Child process did not continue.");
			}
		finis


						/*	Check default action for SIGCONT when process
							is not stopped is to ignore the SIGCONT signal.
						*/
		ENABLE_PSYNC
			prep("Fork a process.");
			start
				sv_flush();
				pid = Zfork();
			finis
	
			if(pid == (pid_t)0) {
				SET_TIMEOUT
					WAIT_PSYNC
				CLEAR_ALARM

				done();
			}
	
			SLEEP(WAIT_FOR_TIME);
	
			prep("Send SIGCONT signal to child.");
			start
				Zkill(pid, SIGCONT);
				SLEEP(WAIT_FOR_TIME);
			finis

			testing("Child process not stopped.");
			start
				if(Zwaitpid(pid, &stat_val, WUNTRACED | WNOHANG) > 0) {
					if(WIFSTOPPED(stat_val)) {
						Zkill(pid, SIGKILL);
						error("Child process is stopped.");
					}
				}
			finis

			SEND_PSYNC
			WAIT_FOR_PID(pid);
		DISABLE_PSYNC
	finis
	
	ass_nu = 18;
	for(i=NSIGS_STOP; i<NSIGS; i++) {
		ass_nu++;
		assertion(ass_nu, BASE);
		start
			prep("Fork a process.");
			start
				if(sigs[i].sig != SIGSTOP) {
					SIGNAL(sigs[i].sig, SIG_DFL);
				}
				sv_flush();
				pid = Zfork();
			finis
	
			if(pid == (pid_t)0) {
				prep("Issue signal %s to child process.", sigs[i].signame);
				start
					Zkill(getpid(), sigs[i].sig);
					SLEEP(WAIT_FOR_TIME);
				finis
	
				done();
			}
	
			SLEEP(WAIT_FOR_TIME);
	
			testing("Child process stopped by %s signal.", sigs[i].signame);
			start
				SET_ALARM(TIMEOUT)
					Zwaitpid(pid, &stat_val, WUNTRACED);
				CLEAR_ALARM
	
				if( ! WIFSTOPPED(stat_val)) 
					error("Process did not stop.");
				else
					if(WSTOPSIG(stat_val) != sigs[i].sig) 
						error("%s\n%s%s\n%s%d",
								"WSTOPSIG not equal to expected signal.",
								"Expected: ",
								sigs[i].signame,
								"Actual signal # : ",
								WTERMSIG(stat_val) );
			finis
	
			cleanup("Terminate stopped child.");
			start
				Zkill(pid, SIGKILL);
				WAIT_FOR_PID(pid);
			finis
		finis
	}

	done();
}
