#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<sv_sigs.h>
#include	<pcts_timer.h>

	
int main(void)
{
	pid_t	pid;
	int		i;
	
	setup(E_SIGNAL_CON);
	funct(E_SIGNAL_CON);

	assertion(35, BASE);
	start
		pid_t	s_pid;

		ENABLE_PSYNC
		for(i=NSIGS_STOP; i<NSIGS; i++) {
			if(sigs[i].sig == SIGSTOP)
				continue;

			prep("Fork a child.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				exit_on(ERROR);
				prep("Ignore SIGHUP signal and set signal %s to SIG_DFL.",
								sigs[i].signame);
				start
					SIGNAL(SIGHUP, SIG_IGN);
					SIGNAL(sigs[i].sig, SIG_DFL);
				finis

				prep("Setup a new process group.");
				start
					Zsetpgid((pid_t)0, (pid_t)0);
				finis

				prep("Fork first grandchild process.");
				start
					sv_flush();
					s_pid = Zfork();
				finis

				if(s_pid == (pid_t)0) {
					prep("Wait while parent process exits and test");
					prep("is performed.");
					start
						sleep(WAIT_FOR_TIME);
						sleep(2 * WAIT_FOR_TIME);
					finis

					done();
				}

				prep("Fork second grandchild process.");
				start
					sv_flush();
					pid = Zfork();
				finis

				if(pid == (pid_t)0) {
					exit_on(ERROR);
					prep("Wait while parent process exits.");
					start
						SET_TIMEOUT
							WAIT_PSYNC
						CLEAR_ALARM
						sleep(WAIT_FOR_TIME);
					finis

					testing("Signal %s from member of orphaned process",
										sigs[i].signame);
					testing("group does not stop the process.");
					start
							/*	Allow for implementation to ignore STOP
								signal or abort the child process.
							*/
						Zkill(s_pid, sigs[i].sig);
						SLEEP(3 * WAIT_FOR_TIME);
						expecting(ESRCH);
						Zkill(s_pid, 0);
					finis

					done();
				}

				prep("Child now exits and is waited for to obtain an");
				prep("orphaned background process group for grandchild.");
				start
					SEND_PSYNC
				finis

				done();
			}
			WAIT_FOR_PID(pid);
			SLEEP(MAX_TIME_TO_RUN);
		}
		DISABLE_PSYNC
	finis
	
	assertion(36, BASE);
	start
		sigset_t	set;

		FORK
			prep("Obtain a pending SIGCHLD signal for the child process.");
			start
						/*	Action of SIG_DFL on signal SIGCHLD does
							not ensure signal will be pending when 
							delivered while blocked.
						*/
				SIGNAL(SIGCHLD, sig_int);
				SIGBLOCK(set, SIGCHLD);
				Zkill(getpid(), SIGCHLD);
				Zsigpending(&set);
				if( ! sigismember(&set, SIGCHLD) )
					error("SIGCHLD signal not pending.");
			finis

			testing("Set action to SIG_DFL for SIGCHLD.");
			start
				SIGNAL(SIGCHLD, SIG_DFL);
			finis

			testing("Signal SIGCHLD no longer pending.");
			start
				Zsigpending(&set);
				if(sigismember(&set, SIGCHLD))
					error("SIGCHLD signal still pending.");
			finis
		KROF
	finis
	
		/* NOTE:  This assertion should be a Reference Assertion to
				  assertions #58 and #59.
		*/
	assertion(37, BASE);
	start
		testing("See assertion tests #58 and #59 for actual result.");
		start
		finis
	finis

	done();
}
