#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

	/* Testing:  read() is reentrant with respect to signals. */

int		pipfd[2];
char	inbuf[1];

static int	catch_sig;
void sig_catch2(int i)
{	
	prep("Entering second signal catching routine.");
	start
		catch_sig++;
	finis
}

void sig_catch(int i)
{	
	prep("Unblock SIGALRM in interrupt catcher.");
	start
		sigset_t sigint;

		sigemptyset(&sigint);
		sigaddset(&sigint, SIGALRM);
		sigprocmask(SIG_UNBLOCK, &sigint, NULL);
	finis

	prep("Set second signal catcher for SIGALRM.");
	start
		expecting(SUCCESS);
		SIGNAL(SIGALRM, sig_catch2);
		catch_sig++;
	finis

	prep("Signal catcher calls read().");
	start
		alarm(WAIT_FOR_TIME);
		errno = 0;
		read(pipfd[0], inbuf , 1);
		if(errno != EINTR)
			error("%s\n%s\n%s%s",
				"Value of errno incorrect from read() in sig_catch().",
				"Expected value corresponding to [EINTR].",
				"Actual value corresponds to ",
				sig_lookup(errno) );
		errno = 0;
	finis

	catch_sig++;
}

int main(void)
{
	pid_t	pid;

	setup(E_SIGNAL_CON);
	ass_nu = 45;
	
	prep("Create a pipe.");
	start
		Zpipe(pipfd);
	finis

	FORK
		prep("Set signal catcher for SIGALRM.");
		start
			SIGNAL(SIGALRM, sig_catch);
		finis
		
		prep("Interrupt read(), by a signal, before reading any data.");
		start
			alarm(WAIT_FOR_TIME);
			errno = 0;
			read(pipfd[0], inbuf , 1);
			if(errno != EINTR)
				error("%s\n%s\n%s%s",
					"Value of errno incorrect from read() in sig_catch().",
					"Expected value corresponding to [EINTR].",
					"Actual value corresponds to ",
					sig_lookup(errno) );
		finis

		testing("The function read() is reentrant with respect to signals.");
		start
			if(catch_sig != 3)
				error("The read() function is not reentrant.");
		finis
	KROF

	done();
}
