#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

	/* Testing:  sleep() is reentrant with respect to signals. */

static	int slp1;
static	int slp2 = MAX_TIME_TO_RUN;
static	int	catch_sig;

void sig_catch2(int i) {catch_sig++;}

void sig_catch(int i)
{	
	prep("Unblock SIGINT in interrupt catcher.");
	start
		sigset_t sigint;

		sigemptyset(&sigint);
		sigaddset(&sigint, SIGINT);
		sigprocmask(SIG_UNBLOCK, &sigint, NULL);
	finis

	prep("Set second signal catcher for SIGINT.");
	start
		SIGNAL(SIGINT, sig_catch2);
	finis

	prep("Signal catcher calls sleep().");
	start
		slp2 = sleep(MAX_TIME_TO_RUN);
	finis
}

int main(void)
{
	pid_t	pid;

	setup(E_SIGNAL_CON);
	ass_nu = 45;

 	prep("Fork a child process to test sleep() reentrancy.");
	start
		sv_flush();
		pid = Zfork();
	finis

	if(pid == (pid_t)0) {
		prep("Set signal catcher for SIGINT and sleep().");
		start
			SIGNAL(SIGINT, sig_catch);
			slp1 = sleep(MAX_TIME_TO_RUN);
		finis
			
		testing("The function sleep() is reentrant with respect to signals.");
		start
			if( ! (	(slp2 != MAX_TIME_TO_RUN) &&
					(slp1 != MAX_TIME_TO_RUN) &&
					(catch_sig == 1) ) )
				error("The sleep() function is not reentrant.");
		finis

		done();
	}

	prep("Issue SIGINT to child.");
	start
		SLEEP(WAIT_FOR_TIME);		/* Allow time for child to call sleep(). */
		Zkill(pid, SIGINT);
	finis

	prep("Issue a second SIGINT to child to interrupt the interrupt.");
	start
		SLEEP(WAIT_FOR_TIME);	/* Allow time for sig_catch() to call sleep().*/
		Zkill(pid, SIGINT);
	finis

	WAIT_FOR_PID(pid);

	done();
}
