#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zgrp.h>

#include	<sv_env.h>


int	main(void)
{
	struct	group   *grp_ptr;
	char	String[1000];
	char	*tok_ptr, *grp_nam;
	gid_t	gid_ent;

	setup(E_GETGRGID);
	funct(E_GETGRGID);

	assertion(4, BASE);
	start
		break_on(ERROR);
		testing("Extraction of group database entry for known group ID.");
		start
			strcpy(String, GDB_ENTRY);
			grp_nam = Zstrtok(String, ",");
			tok_ptr = Zstrtok(NULL, ",");
			gid_ent = (gid_t)atol(tok_ptr);
			if((grp_ptr = getgrgid(gid_ent)) == (struct group *)0)
				error("The getgrgid(%ld) call failed {%s}",
						gid_ent,
						err_lookup(errno));
			if(strcmp(grp_ptr->gr_name, grp_nam) != 0)
				error("%s\n%s%s\n%s%s\n",
						"Group names are not the same.",
						"Expected:	",
						grp_nam,
						"Actual:	",
						grp_ptr->gr_name);

			if(grp_ptr->gr_gid != gid_ent)
				error("%s\n%s%s\n%s%s\n",
						"Group IDs are not the same.",
						"Expected:	",
						gid_ent,
						"Actual:	",
				   		grp_ptr->gr_gid);

			while(*grp_ptr->gr_mem) {
				if(strcmp(*(grp_ptr->gr_mem++), (tok_ptr=strtok(NULL, ","))))
					error("%s\n%s%s\n%s%s\n",
						"Member names are not the same.",
						"Expected:	",
						tok_ptr,
						"Actual:	",
						*grp_ptr->gr_mem);
			}
		finis
	finis

	assertion(5, BASE);
	start
		TYP_CHK_ENTITY(grp_ptr->gr_gid, gid_t);

		TYP_CHK_ENTITY_PTR(grp_ptr->gr_name, char);

		testing("Assignment, comparison, and sizeof \"gr_mem\" to variable");
		testing("of type \"char **\".");
		start
			char  **y;
			
			if(0) {
				y = grp_ptr->gr_mem;
				if(y == grp_ptr->gr_mem)
					;
			}

			if(sizeof(grp_ptr->gr_mem) != sizeof(char **))
				error("%s\nExpecting: %d\nActual: %d",
			  		"Sizeof(char **) does not equal sizeof(grp_ptr->gr_mem)",
			  		sizeof(grp_ptr->gr_mem),
			  		sizeof(char **) );
		finis
	finis

	assertion(6, BASE);
	start
		testing("Call to getgrgid(gid) when \"gid\" is not in the group");
		testing("database.");
		start
			expecting(FAILURE);
			Zgetgrgid(UNUSED_GID);
		finis
	finis

	assertion(7, EXTENDED);

	done();
}
