/*	pcts.h - NIST-PCTS Configuration Parameters */

#ifndef	_POSIX_SOURCE
#define	_POSIX_SOURCE
#endif

#include <version.h>

#define	FIPS_151_NGROUPS_MAX	8

#include <config.h>
#include <sv_conf.h>
#include <pcts_testv.h>

#include <Zstring.h>
#include <stdarg.h>
#include <Zstdio.h>
#include <Zstdlib.h>
#include <stddef.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/Zstat.h>
#include <Zsignal.h>
#include <sys/Zwait.h>
#include <Ztime.h>
#include <limits.h>
#include <pcts_time.h>

#include <pcts_ass.h>

#define	PROT_ALL	((mode_t)(S_IRWXU|S_IRWXG|S_IRWXO))
#define	PERM_CTTY	(S_IWOTH | S_IROTH | S_IWGRP | S_IRGRP | S_IRUSR | S_IWUSR)
#define	TRUE	1
#define	FALSE	0
#define	NOT_TRUE_NOR_FALSE	-1

						/*	Minimum number of supplementary groups a
							FIPS 151-2 conforming implementation may define.
						*/
#define	MIN_SGA_NGROUPS_MAX	8

		/*	Time-related fields checking	*/
#define	CHK_ATIME	1
#define	CHK_MTIME	2
#define	CHK_CTIME	3
#define	TRF_DELAY	11				/* Delay in tenths of seconds.	*/
#define	NO_FILDES	-1
#define	NO_PATH		""

		/*	Read-only file testing */
#define	MOUNT_RO	0			/* Mount read-only  */
#define	MOUNT_RW	1			/* Mount read-write */
#define	NO_FILE		0
#define	ROFS_DIR	1			/* Directory        */
#define	ROFS_REG_FILE	2			/* Regular file     */
#define	ENOSPC_FILE	3			/* Use all file space */

/* ROFS_TESTFILE is the name of file on PCTS_FS for EROFS testing.  */
#define	ROFS_TESTFILE		"rofs_testfile"
/* ROFS_TESTDIR is the name of file on PCTS_FS for EROFS testing.  */
#define	ROFS_TESTDIR		"rofs_testdir"
/* ENOSPC_TESTFILE is the name of file on PCTS_FS for ENOSPC testing.  */
#define	ENOSPC_TESTFILE		"enospc_tstfile"
#define	FS_TESTFILE1		"fs_testfile1"
#define	FS_TESTFILE2		"fs_testfile2"

/* Constants used for determining filename or pathname test */
#define	FILENAME_TEST	1
#define	PATHNAME_TEST	2
#define	SECOND_PATH		0
#define	BLOCK_SPECIAL_PATH	"./STD/DIF/data/dif.d/type.d/mode_cks.d/S_ISBLK"
#define	CHAR_SPECIAL_PATH	"./STD/DIF/data/dif.d/type.d/mode_cks.d/S_ISCHR"

/* SLEEP(time) - required time to sleep */
#define	SLEEP(time) { \
	expecting((unsigned int) 0); \
	(void) Zsleep((unsigned int) time); \
	expecting(SUCCESS); }

#define NOW time((time_t *) 0)

/* BUSY_WAIT(sec ) -- Do a busy wait for 'sec' seconds */
#define BUSY_WAIT(sec) { \
     time_t t; \
     t = NOW + (time_t)sec; \
     while (NOW < t); }


extern	int	wait_for(pid_t, unsigned);
#define WAIT_FOR_PID(pid)  wait_for(pid, MAX_TIME_TO_RUN)
#define	MAX_TIME_TO_RUN	(10*WAIT_FOR_TIME)  /* Maximum time for a test to run */

/* Handle writing of TTY Special Control Characters portably */
#define WRITE_TTY_SCC(fd,tty_scc) { \
	cc_t scc; \
	scc = (cc_t) tty_scc; \
	expecting(sizeof(cc_t)); \
	Zwrite(fd, &scc, sizeof(cc_t)); }


#define	FORK \
		prep("Fork a child."); \
		start \
			pid = Zfork(); \
		finis \
		if(pid == (pid_t)0) {

#define	KROF \
		done(); \
		} \
		WAIT_FOR_PID(pid);


#define	GTI_NOT_PROVIDED (strlen(PORT_TTY)==0 || strlen(PORT_LOOP)==0)
#define	GTI_PROVIDED		(!GTI_NOT_PROVIDED)

#define	GTI_NOT_PROVIDED_EXIT \
		if(GTI_NOT_PROVIDED) { \
			test_rc = NOT_TESTABLE; \
			testing("Testing constraint, GTI devices, not provided."); \
			start \
			finis \
			done(); \
		}

#define	GTI_NOT_PROVIDED_RESULT(ass_num,ass_type) \
		assertion(ass_num, NOT_TESTABLE);
