#ifndef	_POSIX_SOURCE
#define	_POSIX_SOURCE
#endif

#include <sys/types.h>

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>

#include <sv_conf.h>
#include <sv_env.h>


static int exit_val = 0;

void sv_set_exit_val(int x)
{
	exit_val = x;			
}

void sv_done(void)
{
	char tname[64];

	sv_flush();
	sprintf(tname,"%s/tmp/%s/pid.%ld", PCTS_PATH, SUBTMP, (long) getpid());
	unlink(tname);
	_exit(exit_val);
}						

int sv_act(int severity, int action, sigjmp_buf jmp )
{
	if(exit_val < severity) sv_set_exit_val( severity );
	switch(action) {
		case ABORT:
			sv_printf("\tPCTS action taken: ABORT\n");
			sv_flush();
								/* kill all processes in process group. */
			if(kill(0, SIGKILL))
				sv_printf("SEVERR:\n\tCall to kill(0, SIGKILL) failed.\n");
			sv_done();
		case EXIT:
			sv_printf("\tPCTS Action taken: EXIT\n");
			sv_done();
		case BREAK:
			sv_printf("\tPCTS action taken: BREAK\n");
			sv_flush();
			siglongjmp(jmp, severity);
		case CONTINUE:
			sv_printf("\tPCTS action taken: CONTINUE\n");
			sv_flush();
			return(severity);
		default:
			return(WARNING);
	}
}

				/*	Used by some of the STD/LS tests when "exit()" is
					required to be called.
				*/
void done_e(void)
{
	char tname[64];

	sv_flush();
	sprintf(tname, "%s/tmp/%s/pid.%ld", PCTS_PATH, SUBTMP, (long) getpid());
	unlink(tname);
	exit(exit_val);
}						
