#include <pcts.h>

#include <Zunistd.h>
#include <sys/Zwait.h>
#include <subtest.h>	

#include <sv_env.h>

extern	char	**environ;

void subtest(char *file, int e_index)
{
	pid_t	cpid, wpid;
	int 	stat_val;

	prep("Fork a subtest");
	start
		error_on(E_FAILURE);	
		if(!(cpid = Zfork())) {
			char	str_indx[20];

			sprintf(str_indx, "%d", e_index);
			Zexecle(file, file, str_indx, (char *)0, environ);
			error("Attempted execle() of subtest \"%s\" failed.", file);
			done();
		}
		wpid = Zwait(&stat_val);
		if(wpid != cpid) {
			severr("wait(): returned unexpected value: %d", wpid);
		}
		else {
			if(WIFSIGNALED(stat_val)) {
				error("%s%s.\n",
					"Routine subtest() terminated due to signal ",
					sig_lookup(WTERMSIG(stat_val)) );
			}
			else {
				switch(WEXITSTATUS(stat_val)) {
					case 0:
					case MESSAGE:
						break;
					case WARNING:
						warning("Routine subtest() terminated abnormally");
						break;
					case ERROR:
						warning("Routine subtest() terminated abnormally");
						break;
					case SEVERR:
						severr("Routine subtest() terminated abnormally");
						break;
					default:
						error("%s\"%d\"\n",
							"Routine subtest() terminated with unknown status",
							WEXITSTATUS(stat_val) );
				}
			}
		}
	finis
}	
