/* z_cfsetispeed.c */

#include <z_pcts.h>
#include <termios.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	cfsetispeed
#endif

static int success(int *val)
{
	return((*val) == 0);
}

static int failure(int *val)
{
	return((*val) == (-1));
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tcfsetispeed = {
	"cfsetispeed",
	"a return value of 0",
	"not defined",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int  Zcfsetispeed(struct termios *t, speed_t speed)
{
	int ret_val;

	errno = 0;
	ret_val = cfsetispeed(t, speed);
	evaluate(&Tcfsetispeed, (pointer)&ret_val);
	return(ret_val);
}
