/* z_fopen.c */

#include <z_pcts.h>
#include <stdio.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef fopen
#endif

static int success(FILE **val)
{
	return((*val) ? 1 : 0);
}

static int failure(FILE **val)
{
	return((*val) ? 0 : 1);
}

static char *format(FILE **val)
{
	static char buf[STRVAL];

	if(!*val)
		(void) strcpy(buf, "NULL");
	else if((pointer)(*val) == NON_NULL)
		(void) strcpy(buf, "NON-NULL");
	else
		(void) sprintf(buf, "0x%lx", (long)(*val));
	return(buf);
}

static int compare(FILE **a, FILE **b)
{
	if((pointer)(*b) == NON_NULL)
		return((*a) ? 1 : 0);
	return(*a == *b);
}

extern	pointer *sv_getp(void);

static struct ftable Tfopen = {
	"fopen",
	"a return value other than a NULL pointer",
	"a return value of NULL pointer",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_getp,
	1,
};

FILE * Zfopen(char *filename, char *type)
{
	FILE * ret_val;

	errno = 0;
	ret_val = fopen(filename, type);
	evaluate(&Tfopen, (pointer)&ret_val);
	return(ret_val);
}

