/*
 * z_fscanf.c
 *		This function was only written to be used to test assertions
 *		for fscanf.  It will only test a one argument string format.
*/

#include <z_pcts.h>
#include <stdio.h>

#ifdef PCTS_FUNCT_INTF_CK
#undef	fscanf
#endif

static int success(int *val)
{
	return((*val) >= 0);
}

static int failure(int *val)
{
	return((*val) == EOF);
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tfscanf = {
	"fscanf",
	"a return value of at least 0",
	"a return value of EOF",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int	Zfscanf(FILE *stream, char *format, char *arg)
{
	int ret_val;

	errno = 0;
	ret_val = fscanf(stream, format, arg);
	evaluate(&Tfscanf, (pointer)&ret_val);
	return(ret_val);
}
