/* z_ftell.c */

#include <z_pcts.h>
#include <stdio.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef ftell
#endif

static int success(long *val)
{
	return((*val) >= 0);
}

static int failure(long *val)
{
	return(((*val) < 0) ? 1 : 0);
}

static char *format(long *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%ld", *val);
	return(buf);
}

static int compare(long *a, long *b)
{
	return(*a == *b);
}

extern long *sv_getl(void);

static struct ftable Tftell = {
	"ftell",
	"a return value of at least 0",
	"a return value less than 0",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_getl,
	0,
};

long  Zftell(FILE *stream)
{
	long ret_val;

	errno = 0;
	ret_val = ftell(stream);
	evaluate(&Tftell, (pointer)&ret_val);
	return(ret_val);
}
