/* z_getppid.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	getppid
#endif

static int success(pid_t *val)
{
	return((*val) >= 0);
}

static char *format(pid_t *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%ld", (long) *val);
	return(buf);
}

static int compare(pid_t *a, pid_t *b)
{
	return(*a == *b);
}

extern pid_t *sv_gpid_t(void);

static struct ftable Tgetppid = {
	"getppid",
	"a return value of at least 0",
	"not defined",
	format,
	compare,
	success,
	(ifunctptr)0,
	(pfunctptr)sv_gpid_t,
	0,
};

pid_t  Zgetppid(void)
{
	pid_t ret_val;

	errno = 0;
	ret_val = getppid();
	evaluate(&Tgetppid, (pointer)&ret_val);
	return(ret_val);
}
