/* z_getpwuid.c */

#include <z_pcts.h>
#include <pwd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	getpwuid
#endif

static int success(struct passwd **val)
{
	return((*val) != (struct passwd *)0);
}

static int failure(struct passwd **val)
{
	return((*val) == (struct passwd *)0);
}


static char *format(struct passwd **val)
{
	static char buf[STRVAL];

	if(!*val)
		(void) strcpy(buf, "NULL");
	else if((pointer)(*val) == NON_NULL)
		(void) strcpy(buf, "NON-NULL");
	else
		(void) sprintf(buf, "0x%lx", (long)(*val));
	return(buf);
}


static int compare(struct passwd **a, struct passwd **b)
{
	return(*a == *b);
}

extern pointer *sv_getp(void);

static struct ftable Tgetpwuid = {
	"getpwuid",
	"a non-NULL return value",
	"a NULL return value",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_getp,
	1,
};

struct passwd * Zgetpwuid(uid_t uid)
{
	struct passwd *ret_val;

	errno = 0;
	ret_val = getpwuid(uid);
	evaluate(&Tgetpwuid, (pointer)&ret_val);
	return(ret_val);
}
