/* sv_readdir.c */

#include <z_pcts.h>
#include <dirent.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	readdir
#endif

static int success(struct dirent **val)
{
	return((*val) != (struct dirent *) 0);
}

static int failure(struct dirent **val)
{
	return((*val) == (struct dirent *) 0);
}


static char *format(struct dirent **val)
{
	static char buf[STRVAL];

	if(!*val)
		(void) strcpy(buf, "NULL");
	else if((pointer)(*val) == NON_NULL)
		(void) strcpy(buf, "NON-NULL");
	else
		(void) sprintf(buf, "0x%lx", (long)(*val));
	return(buf);
}


static int compare(struct dirent **a, struct dirent **b)
{
	return(*a == *b);
}

extern pointer *sv_getp(void);

static struct ftable Treaddir = {
	"readdir",
	"a non-NULL return value",
	"a NULL return value",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_getp,
	1,
};

struct dirent *Zreaddir(DIR *dirp)
{
	struct dirent *ret_val;

	errno = 0;
	ret_val = readdir(dirp);
	evaluate(&Treaddir, (pointer)&ret_val);
	return(ret_val);
}
