/* z_tcsetpgrp.c */

#include <z_pcts.h>
#include <termios.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	tcsetpgrp
#endif

static int success(int *val)
{
	return((*val) == (0));
}

static int failure(int *val)
{
	return((*val) == (-1));
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Ttcsetpgrp = {
	"tcsetpgrp",
	"a return value of 0",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int  Ztcsetpgrp(int fildes, pid_t pgrp_id)
{
	int ret_val;

	errno = 0;
	ret_val = tcsetpgrp(fildes, pgrp_id);
	evaluate(&Ttcsetpgrp, (pointer)&ret_val);
	return(ret_val);
}
