/* z_times.c */

#include <z_pcts.h>
#include <sys/times.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	times
#endif

static int success(clock_t *val)
{
	return((*val) != (-1));
}

static int failure(clock_t *val)
{
	return((*val) == (-1));
}

static char *format(clock_t *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%ld", *val);
	return(buf);
}

static int compare(clock_t *a, clock_t *b)
{
	return(*a == *b);
}

extern	clock_t *sv_gclk_t(void);

static struct ftable Ttimes = {
	"times",
	"a return value greater than (0)",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_gclk_t,
	0,
};

clock_t  Ztimes(struct tms *buffer)
{
	clock_t ret_val;

	errno = 0;
	ret_val = times(buffer);
	evaluate(&Ttimes, (pointer)&ret_val);
	return(ret_val);
}
